#include "StdAfx.h"
#include "Editor_UndoBuffer.h"

namespace Editor {

	UndoBuffer::UndoBuffer(void)
	{
		m_Operations = gcnew ArrayList();
		m_Counter = 0;
	}

	System::Void UndoBuffer::Add(Editor::Operation^ operation) {//obt@ɒǉB
		//obt@̍Đʒuȍ~̑폜B
		int count = m_Operations->Count - m_Counter;
		if (count > 0) {
			m_Operations->RemoveRange(m_Counter, count);
		}

		//obt@ɒǉB
		m_Operations->Add(operation);
		m_Counter = m_Operations->Count;
	}

	System::Void UndoBuffer::Undo() {//ɖ߂B
		if (m_Counter > 0) {
			m_Counter--;
			safe_cast<Editor::Operation^>(m_Operations[m_Counter])->Undo();
		}
	}

	System::Void UndoBuffer::Redo() {//ɖ߂蒼B
		if (m_Counter < m_Operations->Count) {
			safe_cast<Editor::Operation^>(m_Operations[m_Counter])->Redo();
			m_Counter++;
		}
	}

	String^ UndoBuffer::GetUndoName() {//ɖ߂̖̂𓾂B
		String^ ret = nullptr;

		if (m_Counter > 0) {
			ret = safe_cast<Editor::Operation^>(m_Operations[m_Counter - 1])->Name;
		}

		return ret;
	}

	String^ UndoBuffer::GetRedoName() {//蒼̖̂𓾂B
		String^ ret = nullptr;

		if (m_Operations->Count > m_Counter) {
			ret = safe_cast<Editor::Operation^>(m_Operations[m_Counter])->Name;
		}

		return ret;
	}

}//Editor
