#include "StdAfx.h"
#include "VMD.h"

namespace MMD {

	namespace VMD {

		Item::Item()
		{
			Header = gcnew MMD::VMD::Header();
			Bone = gcnew ArrayList();
			Morph = gcnew ArrayList();
		}

		Item::Item(System::String^ strModelName)
		{
			Header = gcnew MMD::VMD::Header(strModelName);
			Bone = gcnew ArrayList();
			Morph = gcnew ArrayList();
		}

		Item^ Item::Copy() {
			Item^ item = gcnew Item();

			item->FileName = FileName;
			item->Header = Header->Copy();
			item->Bone = gcnew ArrayList();
			for (int i = 0; i < Bone->Count; i++) {
				item->Bone->Add(safe_cast<MMD::VMD::Bone^>(Bone[i])->Copy());
			}
			item->Morph = gcnew ArrayList();
			for (int i = 0; i < Morph->Count; i++) {
				item->Morph->Add(safe_cast<MMD::VMD::Morph^>(Morph[i])->Copy());
			}

			return item;
		}

		System::Void Item::Save(System::String^ filename) {//VMDt@Cւ̏o
			//VMDt@Cۑ
			FileStream^ fs = gcnew FileStream(filename, FileMode::Create);
			BinaryWriter^ bw = gcnew BinaryWriter(fs);

			//wb_̏o
			bw->Write(Header->FileType);
			bw->Write(Header->ModelName->GetByte());

			//{[[V̏o
			if (Bone->Count > 0) {
				//bw->Write(Header->BoneLength);
				bw->Write(Bone->Count);
				for (int i = 0; i < Bone->Count; i++) {
					MMD::VMD::Bone^ bone = safe_cast<MMD::VMD::Bone^>(Bone[i]);
					bw->Write(bone->Name->GetByte());
					bw->Write(bone->FrameNo);
					bw->Write(bone->Pose.Trans.X);
					bw->Write(bone->Pose.Trans.Y);
					bw->Write(bone->Pose.Trans.Z);
					bw->Write(bone->Pose.Rot.X);
					bw->Write(bone->Pose.Rot.Y);
					bw->Write(bone->Pose.Rot.Z);
					bw->Write(bone->Pose.Rot.W);
					bw->Write(bone->bytBCParam);
				}
			}

			//\[V̏o
			if (Morph->Count > 0) {
				bw->Write(Morph->Count);
				for (int i = 0; i < Morph->Count; i++) {
					MMD::VMD::Morph^ morph = safe_cast<MMD::VMD::Morph^>(Morph[i]);
					bw->Write(morph->Name->GetByte());
					bw->Write(morph->FrameNo);
					bw->Write(morph->Value);
				}
			}

			bw->Write(int(0));
			bw->Write(int(0));

			fs->Close();
		}

	} //VMD

}//MMD
