#include "StdAfx.h"
#include "Edit_PatternMove.h"
#include "..\TimeLineForm.h"

namespace MetMotMk {

	namespace Edit {

		PatternMove::PatternMove(System::Windows::Forms::Form^ form, TimeLine^ timeline, int moveTick, int moveY,
									SelectedPatterns^ selectedPatterns, bool updateSelectedRectangle)
		{
			Name = "p^[̈ړ";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_moveTick = moveTick;//tickړ
			m_moveY = moveY;//cړ
			m_selectedPatterns = selectedPatterns->Copy();//Ip^[
			m_updateSelectedRectangle = updateSelectedRectangle;//true=Ip^[̋`̍ČvZKv
		}

		System::Void PatternMove::Do() {//̎s
			for (int i = 0; i < m_selectedPatterns->Count; i++) {
				Pattern^ pat = m_selectedPatterns->GetPatternAt(i);
				pat->Top += m_moveY;
				pat->Begin->GlobalTick += m_moveTick;
				pat->End->GlobalTick += m_moveTick;
				pat->UpdateRectangle();//TCYEʒǔvZ
			}
			if (m_updateSelectedRectangle) {//Ctrl+NbN̂ƂA܂̓Obhɍ킹Ƃ
				m_selectedPatterns->UpdateRectangle();//ʒǔvZȂKv
			}
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}

		System::Void PatternMove::Undo() {//ɖ߂
			for (int i = 0; i < m_selectedPatterns->Count; i++) {
				Pattern^ pat = m_selectedPatterns->GetPatternAt(i);
				pat->Top -= m_moveY;
				pat->Begin->GlobalTick -= m_moveTick;
				pat->End->GlobalTick -= m_moveTick;
				pat->UpdateRectangle();//TCYEʒǔvZ
			}
			if (m_updateSelectedRectangle) {//Ctrl+NbN̂ƂA܂̓Obhɍ킹Ƃ
				m_selectedPatterns->UpdateRectangle();//ʒǔvZȂKv
			}
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}
	}//Edit

}//MetMotMk
