#include "StdAfx.h"
#include "Edit_PatternPaste.h"
#include "..\TimeLineForm.h"

namespace MetMotMk {

	namespace Edit {

		PatternPaste::PatternPaste(System::Windows::Forms::Form^ form, TimeLine^ timeline, Model^ model, ArrayList^ patterns, bool multi_model)
		{
			Name = "p^[̃y[Xg";
			m_form = form;
			m_timeline = timeline;//TimeLineւ̎Q
			m_model = model;//y[Xg郂fւ̎Q
			m_patterns = patterns;//y[Xgp^[̃Xg
			m_multi_model = multi_model;//true=õp^[܂܂
		}

		System::Void PatternPaste::Do() {//̎s
			for (int i = 0; i < m_patterns->Count; i++) {
				Pattern^ pattern = safe_cast<Pattern^>(m_patterns[i]);
				if (m_multi_model) {//f̃p^[܂܂ꍇA܂͑IfȂꍇ
					pattern->Model->AddPattern(pattern);//̃fƓfɓ\t
				} else {//Pꃂf̃p^[̂݊܂܂ꍇ
					m_model->AddPattern(pattern);//Iꂽfɓ\t
				}
			}
			m_timeline->Changed = true;
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			frm->UpdateTimeLine();
		}

		System::Void PatternPaste::Undo() {//ɖ߂
			TimeLineForm^ frm = safe_cast<TimeLineForm^>(m_form);
			for (int i = 0; i < m_patterns->Count; i++) {
				Pattern^ pattern = safe_cast<Pattern^>(m_patterns[i]);
				if (pattern->Selected) {
					frm->selectedPatterns->RemovePattern(pattern);
				}
				pattern->Model->Patterns->Remove(pattern);
			}
			m_timeline->Changed = true;
			frm->UpdateTimeLine();
		}

	}//Edit

}//MetMotMk
