#pragma once


#include "AppInfo.h"
#include "TimeLineForm.h"
#include "TimeLine.h"
#include "SMFView.h"
#include "NewProjectDialog.h"
#include "OptionDialog.h"
#include "NewVersionDialog.h"
#include "..\SMF\SMF.h"
#include "..\SMF\SMF_TempoChange.h"
#include "..\MMD\MMD_Pose.h"
#include "..\MMD\VMD\VMD.h"
#include "..\MMD\VMD\VMD_Morph_Pattern.h"
#include "..\Editor\Editor_UndoBuffer.h"

namespace MetMotMk {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Text;
	using namespace System::Diagnostics;

	/// <summary>
	/// Form1 ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(array<System::String ^> ^args)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//

			config = gcnew MetMotMk::Option::Config();
			ConfigFileName = Application::StartupPath + "\\MetMotMk.ini";
			config->Open(ConfigFileName);//ݒ̓ǂݏo

			switch (config->Window->Pos) {
			case Option::WindowStates::EXIT:
			case Option::WindowStates::PRESENT:
			case Option::WindowStates::SET:
				this->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
				if (config->Window->Left > 0) {
					this->Left = config->Window->Left;
				}
				if (config->Window->Top > 0) {
					this->Top = config->Window->Top;
				}
			}
			switch (config->Window->Size) {
			case Option::WindowStates::EXIT:
			case Option::WindowStates::PRESENT:
			case Option::WindowStates::SET:
				if (config->Window->Width > 0) {
					this->Width = config->Window->Width;
				}
				if (config->Window->Height > 0) {
					this->Height = config->Window->Height;
				}
			}

			timeline = gcnew TimeLine();
			timeline->smf = gcnew SMF::File();
			frmTimeLine = gcnew TimeLineForm();
			frmTimeLine->MdiParent = this;
			frmTimeLine->config = config;
			frmSMF = gcnew SMFView();
			frmSMF->MdiParent = this;
			frmSMF->SetTimeLine(timeline);
			frmSMF->InitEventListview();
			this->menuItemShowMIDIData->Enabled = false;
			this->menuItemShowTimeLine->Enabled = false;
			this->menuItemSaveAsProject->Enabled = false;
			this->menuItemSaveProject->Enabled = false;
			ProjectFileName = nullptr;
			this->menuItemOpenProject->Enabled = true;

			undoBuffer = gcnew Editor::UndoBuffer();
			UndoToolUpdate();

			//
			this->menuItemSaveVMD->Enabled = false;
			this->menuItemOpenMetronome->Enabled = false;

			Args = args;
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	protected: 

	private: array<System::String ^>^ Args;//R}hC
	//private: SMF::File^ smf;//timeline->smf ̂ŁA͔p~B
	private: TimeLine^ timeline;
	private: MMD::VMD::Item^ vmd;
	private: TimeLineForm^ frmTimeLine;
	private: SMFView^ frmSMF;
	private: String^ ProjectFileName;//vWFNg̃t@C
	public: MetMotMk::Option::Config^ config;//IvVݒ
	public: String^ ConfigFileName;//ݒt@CB
	private: Editor::UndoBuffer^ undoBuffer;//AhDobt@

	private: System::Windows::Forms::OpenFileDialog^  openFileDialog1;









	private: System::Windows::Forms::SaveFileDialog^  saveFileDialog1;
	private: System::Windows::Forms::MenuStrip^  menuStripMain;




	private: System::Windows::Forms::ToolStripMenuItem^  menuItemFile;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemNew;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemOpenSMF;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemOpenProject;








	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator1;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemSaveProject;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemSaveAsProject;



	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator2;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemExit;

	private: System::Windows::Forms::ToolStripMenuItem^  menuItemHelp;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemVersion;


	private: System::Windows::Forms::ToolStripMenuItem^  menuItemView;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemShowTimeLine;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemShowMIDIData;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemEdit;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemWindow;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemCascade;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemTileHorizontal;
	private: System::Windows::Forms::ToolStripMenuItem^  menuItemTileVertical;




private: System::Windows::Forms::ToolStripMenuItem^  menuItemNewProject;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemSaveVMD;
private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator3;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemOpenMetronome;
private: System::Windows::Forms::StatusStrip^  statusBar;
private: System::Windows::Forms::ToolStripStatusLabel^  statusMessage;
private: System::Windows::Forms::ToolStripProgressBar^  statusProgressBar;


private: System::Windows::Forms::ToolStripStatusLabel^  statusCursorPos;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemTool;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemToolOption;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemCheckVersion;
private: System::Windows::Forms::ToolStrip^  toolMain;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemManual;
private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator4;
private: System::Windows::Forms::ToolStripButton^  toolBtnUndo;
private: System::Windows::Forms::ToolStripButton^  toolBtnRedo;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditUndo;
private: System::Windows::Forms::ToolStripMenuItem^  menuItemEditRedo;







































	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
			this->openFileDialog1 = (gcnew System::Windows::Forms::OpenFileDialog());
			this->saveFileDialog1 = (gcnew System::Windows::Forms::SaveFileDialog());
			this->menuStripMain = (gcnew System::Windows::Forms::MenuStrip());
			this->menuItemFile = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemNew = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemOpenSMF = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemOpenMetronome = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemNewProject = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemOpenProject = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemSaveProject = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemSaveAsProject = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator2 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemSaveVMD = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator3 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemExit = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEdit = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditUndo = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemEditRedo = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemView = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemShowMIDIData = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemShowTimeLine = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemWindow = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemCascade = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemTileVertical = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemTileHorizontal = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemTool = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemToolOption = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemHelp = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemManual = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator4 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuItemCheckVersion = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuItemVersion = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->statusBar = (gcnew System::Windows::Forms::StatusStrip());
			this->statusMessage = (gcnew System::Windows::Forms::ToolStripStatusLabel());
			this->statusProgressBar = (gcnew System::Windows::Forms::ToolStripProgressBar());
			this->statusCursorPos = (gcnew System::Windows::Forms::ToolStripStatusLabel());
			this->toolMain = (gcnew System::Windows::Forms::ToolStrip());
			this->toolBtnUndo = (gcnew System::Windows::Forms::ToolStripButton());
			this->toolBtnRedo = (gcnew System::Windows::Forms::ToolStripButton());
			this->menuStripMain->SuspendLayout();
			this->statusBar->SuspendLayout();
			this->toolMain->SuspendLayout();
			this->SuspendLayout();
			// 
			// openFileDialog1
			// 
			this->openFileDialog1->FileName = L"openFileDialog1";
			// 
			// menuStripMain
			// 
			this->menuStripMain->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(6) {this->menuItemFile, 
				this->menuItemEdit, this->menuItemView, this->menuItemWindow, this->menuItemTool, this->menuItemHelp});
			this->menuStripMain->Location = System::Drawing::Point(0, 0);
			this->menuStripMain->MdiWindowListItem = this->menuItemWindow;
			this->menuStripMain->Name = L"menuStripMain";
			this->menuStripMain->Size = System::Drawing::Size(784, 26);
			this->menuStripMain->TabIndex = 16;
			this->menuStripMain->Text = L"menuStrip1";
			this->menuStripMain->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::menuStripMain_MouseDown);
			// 
			// menuItemFile
			// 
			this->menuItemFile->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(9) {this->menuItemNew, 
				this->menuItemOpenProject, this->toolStripSeparator1, this->menuItemSaveProject, this->menuItemSaveAsProject, this->toolStripSeparator2, 
				this->menuItemSaveVMD, this->toolStripSeparator3, this->menuItemExit});
			this->menuItemFile->Name = L"menuItemFile";
			this->menuItemFile->Size = System::Drawing::Size(85, 22);
			this->menuItemFile->Text = L"t@C(&F)";
			this->menuItemFile->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::menuItemFile_MouseDown);
			// 
			// menuItemNew
			// 
			this->menuItemNew->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {this->menuItemOpenSMF, 
				this->menuItemOpenMetronome, this->menuItemNewProject});
			this->menuItemNew->Name = L"menuItemNew";
			this->menuItemNew->Size = System::Drawing::Size(274, 22);
			this->menuItemNew->Text = L"VK(&N)";
			// 
			// menuItemOpenSMF
			// 
			this->menuItemOpenSMF->Name = L"menuItemOpenSMF";
			this->menuItemOpenSMF->Size = System::Drawing::Size(204, 22);
			this->menuItemOpenSMF->Text = L"SMFǍ(&S)...";
			this->menuItemOpenSMF->Click += gcnew System::EventHandler(this, &Form1::menuItemOpenSMF_Click);
			// 
			// menuItemOpenMetronome
			// 
			this->menuItemOpenMetronome->Name = L"menuItemOpenMetronome";
			this->menuItemOpenMetronome->Size = System::Drawing::Size(204, 22);
			this->menuItemOpenMetronome->Text = L"gm[Ǎ(&M)...";
			// 
			// menuItemNewProject
			// 
			this->menuItemNewProject->Name = L"menuItemNewProject";
			this->menuItemNewProject->Size = System::Drawing::Size(204, 22);
			this->menuItemNewProject->Text = L"vWFNg(&P)...";
			this->menuItemNewProject->Click += gcnew System::EventHandler(this, &Form1::menuItemNewProject_Click);
			// 
			// menuItemOpenProject
			// 
			this->menuItemOpenProject->Name = L"menuItemOpenProject";
			this->menuItemOpenProject->Size = System::Drawing::Size(274, 22);
			this->menuItemOpenProject->Text = L"vWFNgJ(&O)...";
			this->menuItemOpenProject->Click += gcnew System::EventHandler(this, &Form1::menuItemOpenProject_Click);
			// 
			// toolStripSeparator1
			// 
			this->toolStripSeparator1->Name = L"toolStripSeparator1";
			this->toolStripSeparator1->Size = System::Drawing::Size(271, 6);
			// 
			// menuItemSaveProject
			// 
			this->menuItemSaveProject->Name = L"menuItemSaveProject";
			this->menuItemSaveProject->ShortcutKeyDisplayString = L"Ctrl+S";
			this->menuItemSaveProject->Size = System::Drawing::Size(274, 22);
			this->menuItemSaveProject->Text = L"vWFNgۑ(&S)";
			this->menuItemSaveProject->Click += gcnew System::EventHandler(this, &Form1::menuItemSaveProject_Click);
			// 
			// menuItemSaveAsProject
			// 
			this->menuItemSaveAsProject->Name = L"menuItemSaveAsProject";
			this->menuItemSaveAsProject->Size = System::Drawing::Size(274, 22);
			this->menuItemSaveAsProject->Text = L"OăvWFNgۑ(&A)...";
			this->menuItemSaveAsProject->Click += gcnew System::EventHandler(this, &Form1::menuItemSaveAsProject_Click);
			// 
			// toolStripSeparator2
			// 
			this->toolStripSeparator2->Name = L"toolStripSeparator2";
			this->toolStripSeparator2->Size = System::Drawing::Size(271, 6);
			// 
			// menuItemSaveVMD
			// 
			this->menuItemSaveVMD->Name = L"menuItemSaveVMD";
			this->menuItemSaveVMD->Size = System::Drawing::Size(274, 22);
			this->menuItemSaveVMD->Text = L"ׂẴ[Vf[^ۑ(&V)...";
			this->menuItemSaveVMD->Click += gcnew System::EventHandler(this, &Form1::menuItemSaveVMD_Click);
			// 
			// toolStripSeparator3
			// 
			this->toolStripSeparator3->Name = L"toolStripSeparator3";
			this->toolStripSeparator3->Size = System::Drawing::Size(271, 6);
			// 
			// menuItemExit
			// 
			this->menuItemExit->Name = L"menuItemExit";
			this->menuItemExit->ShortcutKeyDisplayString = L"";
			this->menuItemExit->Size = System::Drawing::Size(274, 22);
			this->menuItemExit->Text = L"I(&X)";
			this->menuItemExit->Click += gcnew System::EventHandler(this, &Form1::menuItemExit_Click);
			// 
			// menuItemEdit
			// 
			this->menuItemEdit->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->menuItemEditUndo, 
				this->menuItemEditRedo});
			this->menuItemEdit->Name = L"menuItemEdit";
			this->menuItemEdit->Size = System::Drawing::Size(61, 22);
			this->menuItemEdit->Text = L"ҏW(&E)";
			this->menuItemEdit->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::menuItemEdit_MouseDown);
			// 
			// menuItemEditUndo
			// 
			this->menuItemEditUndo->Name = L"menuItemEditUndo";
			this->menuItemEditUndo->ShortcutKeyDisplayString = L"Ctrl+Z";
			this->menuItemEditUndo->Size = System::Drawing::Size(190, 22);
			this->menuItemEditUndo->Text = L"ɖ߂(&U)";
			this->menuItemEditUndo->Click += gcnew System::EventHandler(this, &Form1::menuItemEditUndo_Click);
			// 
			// menuItemEditRedo
			// 
			this->menuItemEditRedo->Name = L"menuItemEditRedo";
			this->menuItemEditRedo->ShortcutKeyDisplayString = L"Ctrl+Y";
			this->menuItemEditRedo->Size = System::Drawing::Size(190, 22);
			this->menuItemEditRedo->Text = L"蒼(&R)";
			this->menuItemEditRedo->Click += gcnew System::EventHandler(this, &Form1::menuItemEditRedo_Click);
			// 
			// menuItemView
			// 
			this->menuItemView->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->menuItemShowMIDIData, 
				this->menuItemShowTimeLine});
			this->menuItemView->Name = L"menuItemView";
			this->menuItemView->Size = System::Drawing::Size(62, 22);
			this->menuItemView->Text = L"\(&V)";
			this->menuItemView->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::menuItemView_MouseDown);
			// 
			// menuItemShowMIDIData
			// 
			this->menuItemShowMIDIData->Name = L"menuItemShowMIDIData";
			this->menuItemShowMIDIData->Size = System::Drawing::Size(166, 22);
			this->menuItemShowMIDIData->Text = L"MIDIf[^(&M)";
			this->menuItemShowMIDIData->Click += gcnew System::EventHandler(this, &Form1::menuItemShowMIDIData_Click);
			// 
			// menuItemShowTimeLine
			// 
			this->menuItemShowTimeLine->Name = L"menuItemShowTimeLine";
			this->menuItemShowTimeLine->Size = System::Drawing::Size(166, 22);
			this->menuItemShowTimeLine->Text = L"^CC(&T)";
			this->menuItemShowTimeLine->Click += gcnew System::EventHandler(this, &Form1::menuItemTimeLine_Click);
			// 
			// menuItemWindow
			// 
			this->menuItemWindow->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {this->menuItemCascade, 
				this->menuItemTileVertical, this->menuItemTileHorizontal});
			this->menuItemWindow->Name = L"menuItemWindow";
			this->menuItemWindow->Size = System::Drawing::Size(102, 22);
			this->menuItemWindow->Text = L"EBhE(&W)";
			this->menuItemWindow->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::menuItemWindow_MouseDown);
			// 
			// menuItemCascade
			// 
			this->menuItemCascade->Name = L"menuItemCascade";
			this->menuItemCascade->Size = System::Drawing::Size(191, 22);
			this->menuItemCascade->Text = L"d˂ĕ\(&C)";
			this->menuItemCascade->Click += gcnew System::EventHandler(this, &Form1::menuItemCascade_Click);
			// 
			// menuItemTileVertical
			// 
			this->menuItemTileVertical->Name = L"menuItemTileVertical";
			this->menuItemTileVertical->Size = System::Drawing::Size(191, 22);
			this->menuItemTileVertical->Text = L"Eɕׂĕ\(&V)";
			this->menuItemTileVertical->Click += gcnew System::EventHandler(this, &Form1::menuItemTileVertical_Click);
			// 
			// menuItemTileHorizontal
			// 
			this->menuItemTileHorizontal->Name = L"menuItemTileHorizontal";
			this->menuItemTileHorizontal->Size = System::Drawing::Size(191, 22);
			this->menuItemTileHorizontal->Text = L"㉺ɕׂĕ\(&H)";
			this->menuItemTileHorizontal->Click += gcnew System::EventHandler(this, &Form1::menuItemTileHorizontal_Click);
			// 
			// menuItemTool
			// 
			this->menuItemTool->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->menuItemToolOption});
			this->menuItemTool->Name = L"menuItemTool";
			this->menuItemTool->Size = System::Drawing::Size(74, 22);
			this->menuItemTool->Text = L"c[(&T)";
			this->menuItemTool->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::menuItemTool_MouseDown);
			// 
			// menuItemToolOption
			// 
			this->menuItemToolOption->Name = L"menuItemToolOption";
			this->menuItemToolOption->Size = System::Drawing::Size(167, 22);
			this->menuItemToolOption->Text = L"IvV(&O)...";
			this->menuItemToolOption->Click += gcnew System::EventHandler(this, &Form1::menuItemToolOption_Click);
			// 
			// menuItemHelp
			// 
			this->menuItemHelp->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(4) {this->menuItemManual, 
				this->toolStripSeparator4, this->menuItemCheckVersion, this->menuItemVersion});
			this->menuItemHelp->Name = L"menuItemHelp";
			this->menuItemHelp->Size = System::Drawing::Size(75, 22);
			this->menuItemHelp->Text = L"wv(&H)";
			this->menuItemHelp->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::menuItemHelp_MouseDown);
			// 
			// menuItemManual
			// 
			this->menuItemManual->Name = L"menuItemManual";
			this->menuItemManual->Size = System::Drawing::Size(238, 22);
			this->menuItemManual->Text = L"}jA(&M)";
			this->menuItemManual->ToolTipText = L"http://yuao.o.oo7.jp/doc/MetMotMk/ JB";
			this->menuItemManual->Click += gcnew System::EventHandler(this, &Form1::menuItemManual_Click);
			// 
			// toolStripSeparator4
			// 
			this->toolStripSeparator4->Name = L"toolStripSeparator4";
			this->toolStripSeparator4->Size = System::Drawing::Size(235, 6);
			// 
			// menuItemCheckVersion
			// 
			this->menuItemCheckVersion->Name = L"menuItemCheckVersion";
			this->menuItemCheckVersion->Size = System::Drawing::Size(238, 22);
			this->menuItemCheckVersion->Text = L"ŐVo[W`FbN(&V)...";
			this->menuItemCheckVersion->Click += gcnew System::EventHandler(this, &Form1::menuItemCheckVersion_Click);
			// 
			// menuItemVersion
			// 
			this->menuItemVersion->Name = L"menuItemVersion";
			this->menuItemVersion->Size = System::Drawing::Size(238, 22);
			this->menuItemVersion->Text = L"o[W(&A)...";
			this->menuItemVersion->Click += gcnew System::EventHandler(this, &Form1::menuItemVersion_Click);
			// 
			// statusBar
			// 
			this->statusBar->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {this->statusMessage, this->statusProgressBar, 
				this->statusCursorPos});
			this->statusBar->Location = System::Drawing::Point(0, 535);
			this->statusBar->Name = L"statusBar";
			this->statusBar->Size = System::Drawing::Size(784, 27);
			this->statusBar->TabIndex = 18;
			this->statusBar->Text = L"statusStrip1";
			this->statusBar->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::statusBar_MouseDown);
			// 
			// statusMessage
			// 
			this->statusMessage->AutoSize = false;
			this->statusMessage->BorderSides = static_cast<System::Windows::Forms::ToolStripStatusLabelBorderSides>((((System::Windows::Forms::ToolStripStatusLabelBorderSides::Left | System::Windows::Forms::ToolStripStatusLabelBorderSides::Top) 
				| System::Windows::Forms::ToolStripStatusLabelBorderSides::Right) 
				| System::Windows::Forms::ToolStripStatusLabelBorderSides::Bottom));
			this->statusMessage->BorderStyle = System::Windows::Forms::Border3DStyle::SunkenInner;
			this->statusMessage->Name = L"statusMessage";
			this->statusMessage->Size = System::Drawing::Size(567, 22);
			this->statusMessage->Spring = true;
			this->statusMessage->TextAlign = System::Drawing::ContentAlignment::MiddleLeft;
			this->statusMessage->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::statusMessage_MouseDown);
			// 
			// statusProgressBar
			// 
			this->statusProgressBar->AutoSize = false;
			this->statusProgressBar->Name = L"statusProgressBar";
			this->statusProgressBar->Size = System::Drawing::Size(100, 21);
			this->statusProgressBar->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::statusProgressBar_MouseDown);
			// 
			// statusCursorPos
			// 
			this->statusCursorPos->AutoSize = false;
			this->statusCursorPos->BorderSides = static_cast<System::Windows::Forms::ToolStripStatusLabelBorderSides>((((System::Windows::Forms::ToolStripStatusLabelBorderSides::Left | System::Windows::Forms::ToolStripStatusLabelBorderSides::Top) 
				| System::Windows::Forms::ToolStripStatusLabelBorderSides::Right) 
				| System::Windows::Forms::ToolStripStatusLabelBorderSides::Bottom));
			this->statusCursorPos->BorderStyle = System::Windows::Forms::Border3DStyle::SunkenInner;
			this->statusCursorPos->Name = L"statusCursorPos";
			this->statusCursorPos->Size = System::Drawing::Size(100, 22);
			this->statusCursorPos->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			this->statusCursorPos->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::statusCursorPos_MouseDown);
			// 
			// toolMain
			// 
			this->toolMain->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->toolBtnUndo, this->toolBtnRedo});
			this->toolMain->Location = System::Drawing::Point(0, 26);
			this->toolMain->Name = L"toolMain";
			this->toolMain->Size = System::Drawing::Size(784, 25);
			this->toolMain->TabIndex = 20;
			this->toolMain->Text = L"toolStrip1";
			this->toolMain->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::toolMain_MouseDown);
			// 
			// toolBtnUndo
			// 
			this->toolBtnUndo->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->toolBtnUndo->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolBtnUndo.Image")));
			this->toolBtnUndo->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->toolBtnUndo->Name = L"toolBtnUndo";
			this->toolBtnUndo->Size = System::Drawing::Size(23, 22);
			this->toolBtnUndo->Text = L"toolStripButton1";
			this->toolBtnUndo->ToolTipText = L"ɖ߂";
			this->toolBtnUndo->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::toolBtnUndo_MouseDown);
			this->toolBtnUndo->Click += gcnew System::EventHandler(this, &Form1::toolBtnUndo_Click);
			// 
			// toolBtnRedo
			// 
			this->toolBtnRedo->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->toolBtnRedo->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolBtnRedo.Image")));
			this->toolBtnRedo->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->toolBtnRedo->Name = L"toolBtnRedo";
			this->toolBtnRedo->Size = System::Drawing::Size(23, 22);
			this->toolBtnRedo->Text = L"toolStripButton2";
			this->toolBtnRedo->ToolTipText = L"蒼";
			this->toolBtnRedo->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::toolBtnRedo_MouseDown);
			this->toolBtnRedo->Click += gcnew System::EventHandler(this, &Form1::toolBtnRedo_Click);
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(784, 562);
			this->Controls->Add(this->toolMain);
			this->Controls->Add(this->statusBar);
			this->Controls->Add(this->menuStripMain);
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->IsMdiContainer = true;
			this->KeyPreview = true;
			this->MainMenuStrip = this->menuStripMain;
			this->Name = L"Form1";
			this->Text = L"Metronome Motion Maker";
			this->Shown += gcnew System::EventHandler(this, &Form1::Form1_Shown);
			this->Move += gcnew System::EventHandler(this, &Form1::Form1_Move);
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &Form1::Form1_FormClosing);
			this->Resize += gcnew System::EventHandler(this, &Form1::Form1_Resize);
			this->KeyDown += gcnew System::Windows::Forms::KeyEventHandler(this, &Form1::Form1_KeyDown);
			this->menuStripMain->ResumeLayout(false);
			this->menuStripMain->PerformLayout();
			this->statusBar->ResumeLayout(false);
			this->statusBar->PerformLayout();
			this->toolMain->ResumeLayout(false);
			this->toolMain->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion



	private:
		System::Void Open_SMF() {//X^_[hMIDIt@Cǂݍ
			bool menuItemShowTimeLineEnabled_bak = menuItemShowTimeLine->Enabled;
			bool menuItemShowMIDIDataEnabled_bak = menuItemShowMIDIData->Enabled;
			bool menuItemSaveAsProjectEnabled_bak = menuItemSaveAsProject->Enabled;
			bool menuItemSaveProjectEnabled_bak = menuItemSaveProject->Enabled;
			menuItemSaveAsProject->Enabled = false;
			menuItemSaveProject->Enabled = false;
			menuItemShowMIDIData->Enabled = false;
			menuItemShowTimeLine->Enabled = false;

			openFileDialog1->FileName = "";
			openFileDialog1->InitialDirectory = config->Path->MIDI;
			openFileDialog1->Filter = "Standard MIDI File|*.mid;*.smf|ׂẴt@C|*.*";
			openFileDialog1->Title = "X^_[hMIDIt@C̓Ǎ";
			if(openFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::OK) {
				this->Cursor = Cursors::WaitCursor;

				ProjectFileName = nullptr;
				this->Text = "Metronome Motion Maker - " + "VKvWFNg";
				
				timeline = gcnew TimeLine();
				timeline->smf = gcnew SMF::File();

				//t@Cǂݍ
				timeline->smf->Open(openFileDialog1->FileName);


				//MIDIf[^EBhE̕\
				frmSMF->Close();
				ShowMIDIData();

				//^CCEBhE̕\
				frmTimeLine->Close();
				ShowTimeLine(true);

				if (config->Window->MDIChildMaximized) {
					frmTimeLine->WindowState = System::Windows::Forms::FormWindowState::Maximized;
				} else {
					frmTimeLine->WindowState = System::Windows::Forms::FormWindowState::Normal;
				}

				//AhDobt@̏
				undoBuffer = gcnew Editor::UndoBuffer();
				UndoToolUpdate();

				this->menuItemShowMIDIData->Enabled = true;
				this->menuItemShowTimeLine->Enabled = true;
				this->menuItemSaveAsProject->Enabled = true;
				this->menuItemSaveProject->Enabled = true;

				this->SetStatusProgressBar(0);
				this->Cursor = Cursors::Default;
			} else {//SMFǍLZ
				this->menuItemShowMIDIData->Enabled = menuItemShowMIDIDataEnabled_bak;
				this->menuItemShowTimeLine->Enabled = menuItemShowTimeLineEnabled_bak;
				this->menuItemSaveAsProject->Enabled = menuItemSaveAsProjectEnabled_bak;
				this->menuItemSaveProject->Enabled = menuItemSaveProjectEnabled_bak;
			}

		}

	private:
		System::Void Save_VMD() {//VMDt@Cɕۑ
			saveFileDialog1->InitialDirectory = config->Path->MMD_Motion;
			saveFileDialog1->Filter = "Vocaloid Motion Data files|*.vmd|ׂẴt@C|*.*";
			saveFileDialog1->Title = "VMDt@C̕ۑ";
			if(saveFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::OK) {
				SaveMetronomeMotion(saveFileDialog1->FileName);
			}
		}

	public:
		System::Void SaveMetronomeMotion(String^ filename) {//gm[̃[V̕ۑ
			//VMDۑpf[^̍쐬
			vmd = gcnew MMD::VMD::Item("gm[");

			//Uq{[̃L[t[ݒ
			int v = 0;
			int tick = 0;
			int bcp = 0;//ݎgp̔q̔qύXւ̃|C^
			SMF::BeatChange^ bc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp]);//ݎgp̔q̔qύX
			int dt = timeline->smf->Header.DeltaTime * bc->BeatInfo->cc / 24;
			for (int i = 0; i < timeline->smf->TempoChanges->Count - 1; i++) {
				//iԖڂ̃e|`FWticki+1Ԗڂ̃e|`FWtick܂ł̊ԁAiԖڂ̃e|Kp
				int tick_bak = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i])->Tick;
				int nextTick= safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i+1])->Tick;
				double frame_bak = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i])->Frame;
				double tempo_bak = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i])->Tempo;
				if (i == timeline->smf->TempoChanges->Count - 2) {//Ō4ǉ
					nextTick = timeline->smf->MaxTick + 4 * dt;
				}

				while (tick <= nextTick) {
					if (bcp < timeline->smf->BeatChanges->Count - 1) {
						SMF::BeatChange^ nbc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp+1]);//̔q̔qύX
						if (tick >= nbc->Tick) {//ϐtick̔qύXtickȍ~ł΁Abcp1i߂B
							bcp++;
							bc = nbc;
							dt = timeline->smf->Header.DeltaTime * bc->BeatInfo->cc / 24;
						}
					} else {
						//̔qύX݂Ȃꍇ́AȂB
					}

					MMD::VMD::Bone^ bone = gcnew MMD::VMD::Bone();
					bone->SetName("Uq");
					bone->FrameNo = (int)System::Math::Round(frame_bak + (tick - tick_bak) * 60.0 * 30.0 / (timeline->smf->Header.DeltaTime * tempo_bak));
					bone->Pose.Trans.X = bone->Pose.Trans.Y = bone->Pose.Trans.Z = (float)0.0;
					bone->Pose.Rot.X = bone->Pose.Rot.Y = (float)0.0;

					if (v & 1) {//t[
						bone->Pose.Rot.Z = (float)-0.1736481;
						bone->Pose.Rot.W = (float)0.9848077;
					} else {//t[
						bone->Pose.Rot.Z = (float)0.1736481;
						bone->Pose.Rot.W = (float)0.9848077;
					}

					vmd->Bone->Add(bone);

					tick += dt;
					v++;
				}
			}
			vmd->Header->BoneLength = v;//()

			//x[^[̃L[t[p^[ݒ
			bcp = 0;//ݎgp̔q̔qύXւ̃|C^
			bc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp]);//ݎgp̔q̔qύX
			dt = timeline->smf->Header.DeltaTime * bc->BeatInfo->cc / 24;
			int tick_step = dt / 4;//p^[CxgԂ̃Xebv
			int nPatterns = 8;//[vp^[
			array<MMD::VMD::Morph_Pattern^>^ pattern = gcnew array<MMD::VMD::Morph_Pattern^>(nPatterns);//p^[̔z
			
			//X̃p^[CX^X̍쐬
			for (int i = 0; i < nPatterns; i++) {
				pattern[i] = gcnew MMD::VMD::Morph_Pattern;
			}

			//㑱̃p^[̐ݒ
			for (int i = 0; i < nPatterns - 1; i++) {
				pattern[i]->Next = pattern[i+1];
			}
			pattern[nPatterns-1]->Next = pattern[0];

			//p^[̒`
			double gate = 0.4;//Z銄
			//uṽm[gI(0; l̕\=240 ̏ꍇ)
			pattern[0]->SetName("");
			pattern[0]->Tick = 0 * tick_step;
			pattern[0]->MuteFrame = -2;
			pattern[0]->Value = (float)0.7;
			//uṽm[gIt(60)
			pattern[1]->SetName("");
			pattern[1]->Tick = 1 * tick_step;
			pattern[1]->TickShift = -int(tick_step * gate);
			pattern[1]->MuteFrame = 2;
			pattern[1]->Value = (float)0.7;
			//uṽm[gI(120)
			pattern[2]->SetName("");
			pattern[2]->Tick = 2 * tick_step;
			pattern[2]->MuteFrame = -2;
			pattern[2]->Value = (float)0.5;//(){́uv=0.5;uv=0.3
			//uṽm[gIt(180)
			pattern[3]->SetName("");
			pattern[3]->Tick = 3 * tick_step;
			pattern[3]->TickShift = -int(tick_step * gate);
			pattern[3]->MuteFrame = 2;
			pattern[3]->Value = (float)0.5;
			//uṽm[gI(240)
			pattern[4]->SetName("");
			pattern[4]->Tick = 4 * tick_step;
			pattern[4]->MuteFrame = -2;
			pattern[4]->Value = (float)0.7;
			//uṽm[gIt(300)
			pattern[5]->SetName("");
			pattern[5]->Tick = 5 * tick_step;
			pattern[5]->TickShift = -int(tick_step * gate);
			pattern[5]->MuteFrame = 2;
			pattern[5]->Value = (float)0.7;
			//uṽm[gI(360)
			pattern[6]->SetName("");
			pattern[6]->Tick = 6 * tick_step;
			pattern[6]->MuteFrame = -2;
			pattern[6]->Value = (float)0.5;
			//uṽm[gIt(420)
			pattern[7]->SetName("");
			pattern[7]->Tick = 7 * tick_step;
			pattern[7]->TickShift = -int(tick_step * gate);
			pattern[7]->MuteFrame = 2;
			pattern[7]->Value = (float)0.5;

			//x[^[̃L[t[ݒ
			int p = 0;
			double prevValue = -1.0;
			v = 0;
			tick = 0;
			MMD::VMD::Morph^ morph;
			for (int i = 0; i < timeline->smf->TempoChanges->Count - 1; i++) {
				//iԖڂ̃e|`FWticki+1Ԗڂ̃e|`FWtick܂ł̊ԁAiԖڂ̃e|Kp
				int tick_bak = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i])->Tick;
				int nextTick= safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i+1])->Tick;
				double frame_bak = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i])->Frame;
				double tempo_bak = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i])->Tempo;
				unsigned int frame;
				if (i == timeline->smf->TempoChanges->Count - 2) {//Ō4ǉ
					//nextTick += 4 * dt;
					nextTick = timeline->smf->MaxTick + 4 * dt;
				}
				while (tick <= nextTick) {
					if (bcp < timeline->smf->BeatChanges->Count - 1) {
						SMF::BeatChange^ nbc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp+1]);//̔q̔qύX
						if (tick >= nbc->Tick) {//ϐtick̔qύXtickȍ~ł΁Abcp1i߂B
							bcp++;
							bc = nbc;
							dt = timeline->smf->Header.DeltaTime * bc->BeatInfo->cc / 24;
							tick_step = dt / 4;
							for (int i = 0; i < nPatterns; i++) {
								pattern[i]->Tick = i * tick_step;
								if (i & 1) {//ڂ̃p^[̂Ƃ
									pattern[i]->TickShift = -int(tick_step * gate);
								}
							}
						}
					} else {
						//̔qύX݂Ȃꍇ́AȂB
					}

					frame = (int)System::Math::Round(frame_bak + (tick + pattern[p]->TickShift - tick_bak) * 60.0 * 30.0 / (timeline->smf->Header.DeltaTime * tempo_bak));
					if (pattern[p]->Name->ToString() == "") {//uv̂Ƃ
						//JĂt[uv
						morph = gcnew MMD::VMD::Morph();
						morph->SetName("");
						morph->FrameNo = frame;
						morph->Value = (float)0.5;
						vmd->Morph->Add(morph);
						v++;
						//JĂt[uv
						morph = gcnew MMD::VMD::Morph();
						morph->SetName("");
						morph->FrameNo = frame;
						morph->Value = (float)0.3;
						vmd->Morph->Add(morph);
						v++;
						//if (frame + pattern[p]->MuteFrame >= 0) {//vZʂ unsigned ɂȂĂ܂
						if (frame >= 2) {
							//Ăt[uv
							morph = gcnew MMD::VMD::Morph();
							morph->SetName("");
							morph->FrameNo = frame + pattern[p]->MuteFrame;
							morph->Value = (float)0.0;
							vmd->Morph->Add(morph);
							v++;
							//Ăt[uv
							morph = gcnew MMD::VMD::Morph();
							morph->SetName("");
							morph->FrameNo = frame + pattern[p]->MuteFrame;
							morph->Value = (float)0.0;
							vmd->Morph->Add(morph);
							v++;
						}
					} else {//uvuv̂Ƃ
						//JĂt[
						morph = gcnew MMD::VMD::Morph();
						morph->SetName(pattern[p]->Name->ToString());
						morph->FrameNo = frame;
						if ((tick - bc->Tick) % (bc->BeatInfo->nn * dt) == 0) {//߂̓̂Ƃ
							morph->Value = (float)(prevValue = 1.0);//x[^[Ԃ܂ŏグ
						} else if (prevValue > 0.0) {//ǑJt[̒l1.0̂Ƃ
							morph->Value = (float)prevValue;//1.0ɂ
							prevValue = -1.0;
						} else {
							morph->Value = pattern[p]->Value;
						}
						vmd->Morph->Add(morph);
						v++;
						//if (frame + pattern[p]->MuteFrame >= 0) {//vZʂ unsigned ɂȂĂ܂
						if (frame >= 2) {
							//Ăt[
							morph = gcnew MMD::VMD::Morph();
							morph->SetName(pattern[p]->Name->ToString());
							morph->FrameNo = frame + pattern[p]->MuteFrame;
							morph->Value = 0.0;
							vmd->Morph->Add(morph);
							v++;
						}
					}
					tick += tick_step;
					p++;
					if (p >= nPatterns) p = 0;
				}
			}

			//̃L[t[ݒ(v = (208 - tempo) / 168)
			bcp = 0;//ݎgp̔q̔qύXւ̃|C^
			bc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp]);//ݎgp̔q̔qύX
			double mt = 24.0 / bc->BeatInfo->cc;
			double mt_bak = 0.0;
			double tempo_bak = 0.0;
			for (int i = 0; i < timeline->smf->TempoChanges->Count - 1; i++) {
				int tick = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i])->Tick;
				double tempo = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i])->Tempo;
				unsigned int frame = (int)System::Math::Round(safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i])->Frame);

				if (bcp < timeline->smf->BeatChanges->Count - 1) {
					SMF::BeatChange^ nbc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[bcp+1]);//̔q̔qύX
					if (tick >= nbc->Tick) {//ϐtick̔qύXtickȍ~ł΁Abcp1i߂B
						bcp++;
						bc = nbc;
						mt = 24.0 / bc->BeatInfo->cc;
					}
				} else {
					//̔qύX݂Ȃꍇ́AȂB
				}

				if (frame >= 2) {//e|`FWÕe|
					morph = gcnew MMD::VMD::Morph();
					morph->SetName("");
					morph->FrameNo = frame - 2;
					double tmp = (208.0 - tempo_bak * mt_bak) / 168.0;
					if (tmp < 0.0 ) {
						tmp = 0.0;
					} else if (tmp > 1.0) {
						tmp = 1.0;
					}
					morph->Value = (float)tmp;
					vmd->Morph->Add(morph);
					v++;
				}
				//e|`FW̃e|
				morph = gcnew MMD::VMD::Morph();
				morph->SetName("");
				morph->FrameNo = frame;
				double tmp = (208.0 - tempo * mt) / 168.0;
				if (tmp < 0.0 ) {
					tmp = 0.0;
				} else if (tmp > 1.0) {
					tmp = 1.0;
				}
				morph->Value = (float)tmp;
				vmd->Morph->Add(morph);
				v++;
				tempo_bak = tempo;
				mt_bak = mt;
			}
			vmd->Header->MorphLength = v;//()

/*
			//\[g
			for (int i = 0; i < vmd->Header->MorphLength - 1; i++) {
				for (int j = i + 1; j < vmd->Header->MorphLength; j++) {
					if (vmd->Morph[i]->FrameNo > vmd->Morph[j]->FrameNo) {
						VMD_Morph^ tmp = vmd->Morph[i];
						vmd->Morph[i] = vmd->Morph[j];
						vmd->Morph[j] = tmp;
					}
				}
			}
*/

			//VMDt@Cۑ
			vmd->Save(filename);
		}

	private:
		System::Void VMD_Open_Test() {//Ƃ肠VMDǂݍł݂eXg	 
			openFileDialog1->InitialDirectory = config->Path->MMD_Motion;
			openFileDialog1->Filter = "VMDt@C|*.vmd|ׂẴt@C|*.*";
			openFileDialog1->Title = "VMDt@C̓Ǎ";
			if(openFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::OK) {
				BinaryReader^ br = gcnew BinaryReader( File::Open( openFileDialog1->FileName, FileMode::Open ) );
				br->ReadBytes(50);
				unsigned int frames = br->ReadUInt32();
				for (unsigned int i = 0; i < frames; i++) {
					array<Byte>^ byt = br->ReadBytes(15);
					array<Byte>^ cpy;
					for (int j = 0; j < 15; j++) {
						if (byt[j] == 0) {
							cpy = gcnew array<Byte>(j);
							for (int k = 0; k <= j-1; k++) {
								cpy[k] = byt[k];
							}
							break;
						}
					}
					String^ str = Encoding::GetEncoding("Shift_JIS")->GetString(cpy);
					unsigned int frame = br->ReadUInt32();
					float x = br->ReadSingle();
					float y = br->ReadSingle();
					float z = br->ReadSingle();
					float qx = br->ReadSingle();
					float qy = br->ReadSingle();
					float qz = br->ReadSingle();
					float qw = br->ReadSingle();
					br->ReadBytes(64);
					if (MessageBox::Show(str + String::Format(":[{0:D}] ({8:D}/{9:D}) ({1:E},{2:E},{3:E}), ({4:E},{5:E},{6:E},{7:E})",
								frame, x, y, z, qx, qy, qz, qw, i+1, frames), "data", System::Windows::Forms::MessageBoxButtons::OKCancel)
								== System::Windows::Forms::DialogResult::Cancel) {
						break;
					}
				}
				frames = br->ReadUInt32();
				for (unsigned int i = 0; i < frames; i++) {
					array<Byte>^ byt = br->ReadBytes(15);
					array<Byte>^ cpy;
					for (int j = 0; j < 15; j++) {
						if (byt[j] == 0) {
							cpy = gcnew array<Byte>(j);
							for (int k = 0; k <= j-1; k++) {
								cpy[k] = byt[k];
							}
							break;
						}
					}
					String^ str = Encoding::GetEncoding("Shift_JIS")->GetString(cpy);
					unsigned int frame = br->ReadUInt32();
					float x = br->ReadSingle();
					if (MessageBox::Show(str + String::Format(":[{0:D}] ({2:D}/{3:D}) {1:E}", frame, x, i+1, frames), "data",
						System::Windows::Forms::MessageBoxButtons::OKCancel) == System::Windows::Forms::DialogResult::Cancel) {
						break;
					}
				}
				br->Close();
			}

		}

	private:
		System::Void menuItemVersion_Click(System::Object^  sender, System::EventArgs^  e) {//o[W
			AppInfo^ dlg = gcnew AppInfo();

			dlg->ShowDialog(this);
		}

	private:
		System::Void menuItemOpenSMF_Click(System::Object^  sender, System::EventArgs^  e) {//SMFǍ(VKvWFNg)
			if (FileConfirmation()) {//f[^ύXmF
				Open_SMF();//X^_[hMIDIt@Cǂݍ
			}
		}

	private:
		System::Void menuItemSaveVMD_Click(System::Object^  sender, System::EventArgs^  e) {//VMDۑ
			Save_VMD();//VMDt@Cɕۑ
		}

	private:
		System::Void menuItemTimeLine_Click(System::Object^  sender, System::EventArgs^  e) {//^CC\
			ShowTimeLine(false);//^CCEBhE̕\
		}

	private:
		System::Void menuItemShowMIDIData_Click(System::Object^  sender, System::EventArgs^  e) {//MIDIf[^\
			ShowMIDIData();//MIDIf[^EBhE̕\
		}

	private:
		System::Void ShowMIDIData() {//MIDIf[^EBhE̕\
			if (frmSMF == nullptr || !frmSMF->Created) {
				delete frmSMF;
				frmSMF = gcnew SMFView();
				frmSMF->SetTimeLine(timeline);
				frmSMF->DrawListview();
				frmSMF->MdiParent = this;
			}
			frmSMF->Show();
			frmSMF->Activate();
		}

	private:
		System::Void ShowTimeLine(bool New) {//^CCEBhE̕\(New = true = VKvWFNg)
			if (frmTimeLine == nullptr || !frmTimeLine->Created) {
				delete frmTimeLine;
				frmTimeLine = gcnew TimeLineForm();
				frmTimeLine->SetTimeLine(timeline);
				frmTimeLine->MdiParent = this;
				frmTimeLine->config = config;
				if (New && config->Edit->ShowModel) {
					Model^ model = gcnew Model();
					model->Name = gcnew MMD::String(config->Edit->ModelName);
					model->Height = config->Edit->DefaultModelHeight;
					timeline->Models->Add(model);

					frmTimeLine->ModelLayout();//fg̃CAEǧvZ
				}
			}
			frmTimeLine->Show();
			frmTimeLine->Activate();
		}

	public:
		System::Void UpdateMIDIData() {//MIDIf[^EBhE̕\XV
			frmSMF->DrawListview();
		}

	public:
		System::Void UpdateSongLength() {//MIDIf[^EBhE̋Ȓ̕\XV
			frmSMF->UpdateSongLength();
		}

	public:
		System::Void UpdateTimeLine() {//^CCEBhE̕\XV
			frmTimeLine->SetTimeLine(timeline);
			frmTimeLine->UpdateTimeLine();
		}

	private:
		System::Void menuItemExit_Click(System::Object^  sender, System::EventArgs^  e) {//I
			this->Close();
		}

	private:
		System::Void Form1_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) {//~{^
			if (FileConfirmation()) {//f[^ύXmF
				if (config->Window->Pos == Option::WindowStates::EXIT || config->Window->Size == Option::WindowStates::EXIT) {
					if (config->Window->Pos == Option::WindowStates::EXIT) {//ÏʒuۑƂ
						config->Window->Left = this->Left;
						config->Window->Top = this->Top;
					}
					if (config->Window->Size == Option::WindowStates::EXIT) {//ĨTCYۑƂ
						config->Window->Width = this->Width;
						config->Window->Height = this->Height;
					}
					config->Save(ConfigFileName);//ݒ̕ۑ
				}
				frmTimeLine->Close();
				delete frmTimeLine;
				frmSMF->Close();
				delete frmSMF;
				e->Cancel = false;
			} else {
				e->Cancel = true;
			}
		}

	private:
		System::Void menuItemCascade_Click(System::Object^  sender, System::EventArgs^  e) {//d˂ĕ\
			LayoutMdi(MdiLayout::Cascade);
		}

	private:
		System::Void menuItemTileHorizontal_Click(System::Object^  sender, System::EventArgs^  e) {//㉺ɕׂĕ\
			LayoutMdi(MdiLayout::TileHorizontal);
		}

	private:
		System::Void menuItemTileVertical_Click(System::Object^  sender, System::EventArgs^  e) {//Eɕׂĕ\
			LayoutMdi(MdiLayout::TileVertical);
		}

	private:
		System::Void menuItemNewProject_Click(System::Object^  sender, System::EventArgs^  e) {//VKvWFNg
			if (FileConfirmation()) {//f[^ύXmF
				bool menuItemShowTimeLineEnabled_bak = menuItemShowTimeLine->Enabled;
				bool menuItemShowMIDIDataEnabled_bak = menuItemShowMIDIData->Enabled;
				bool menuItemSaveAsProjectEnabled_bak = menuItemSaveAsProject->Enabled;
				bool menuItemSaveProjectEnabled_bak = menuItemSaveProject->Enabled;
				menuItemSaveAsProject->Enabled = false;
				menuItemSaveProject->Enabled = false;
				menuItemShowMIDIData->Enabled = false;
				menuItemShowTimeLine->Enabled = false;

				NewProjectDialog^ dlg = gcnew NewProjectDialog();
				System::Windows::Forms::DialogResult result = dlg->ShowDialog();

				if (result == System::Windows::Forms::DialogResult::OK) {//VKvWFNg̍쐬B

					frmTimeLine->Close();
					delete frmTimeLine;
					frmSMF->Close();
					delete frmSMF;
					delete timeline;

					ProjectFileName = nullptr;
					this->Text = "Metronome Motion Maker - " + "VKvWFNg";

					timeline = gcnew TimeLine();
					timeline->smf = gcnew SMF::File();

					timeline->smf->Filename = nullptr;
					timeline->smf->Header.DeltaTime = dlg->DeltaTime;
					timeline->smf->Header.Format = 1;
					timeline->smf->MinTick = timeline->smf->Header.DeltaTime * dlg->BeatNN * 4 / dlg->BeatDD;//1ߕtick
					int maxTick = 0;
					switch (dlg->TimeUnit) {
					case TimeUnits::MINUTES:
						//b300bƂ̎w
						maxTick = timeline->smf->Header.DeltaTime * dlg->Tempo * dlg->Minutes
												+ timeline->smf->Header.DeltaTime * dlg->Tempo * dlg->Seconds / 60;
						break;
					case TimeUnits::MEASURES:
						maxTick = dlg->Measures * timeline->smf->MinTick;//ߐ * 1ߕtick
						break;
					case TimeUnits::FRAMES:
						maxTick = timeline->smf->Header.DeltaTime * dlg->Tempo * dlg->Frames / (30 * 60);
					}
					timeline->smf->Header.Tracks = 1;
					timeline->smf->Tracks = gcnew array<SMF::Track^>(timeline->smf->Header.Tracks);
					timeline->smf->Tracks[0] = gcnew SMF::Track();

					//Ȃ̓̔qύX
					SMF::Beat^ beat = gcnew SMF::Beat();
					beat->SetBeat(dlg->BeatNN, dlg->BeatDD, 24 * 4 / dlg->BeatDD, 8);
					SMF::BeatChange^ bc = gcnew SMF::BeatChange(beat, 0);
					bc->Measure = 1;//Ȃ̓
					timeline->smf->BeatChanges = gcnew ArrayList();
					timeline->smf->BeatChanges->Add(bc);
					SMF::Event^ ev = gcnew SMF::Event();
					ev->DeltaTime = 0;
					ev->GlobalTick = 0;
					ev->status = 0x58;
					ev->Data = gcnew array<Byte>(4);
					ev->Data[0] = beat->nn;
					ev->Data[1] = 1;
					for (int i = 2; i < beat->dd; i <<= 1) {
						ev->Data[1]++;
					}
					ev->Data[2] = beat->cc;
					ev->Data[3] = beat->bb;
					timeline->smf->Tracks[0]->Events->Add(ev);

					//Ȃ̓̃e|`FW
					SMF::TempoChange^ tc = gcnew SMF::TempoChange();
					tc->Track = 0;
					tc->Tick = 0;
					tc->Tempo = (double)dlg->Tempo;
					tc->Frame = 0.0;
					timeline->smf->TempoChanges = gcnew ArrayList();
					timeline->smf->TempoChanges->Add(tc);
					ev = gcnew SMF::Event();
					ev->DeltaTime = 0;
					ev->GlobalTick = 0;
					ev->status = 0x51;
					ev->Data = gcnew array<Byte>(3);
					int tempo = (int)System::Math::Round(60.0 * 1000.0 * 1000.0 / tc->Tempo);
					ev->Data[0] = (tempo >> 16) & 0xff;
					ev->Data[1] = (tempo >> 8) & 0xff;
					ev->Data[2] = tempo & 0xff;
					timeline->smf->Tracks[0]->Events->Add(ev);

					//Ȃ̍Ō̃e|`FW
					tc = gcnew SMF::TempoChange();
					tc->Track = 0;
					tc->Tick = maxTick;
					tc->Tempo = (double)dlg->Tempo;
					tc->Frame = maxTick * 30.0 * 60.0 / (timeline->smf->Header.DeltaTime * dlg->Tempo);
					timeline->smf->TempoChanges->Add(tc);

					//GhIugbN
					ev = gcnew SMF::Event();
					ev->DeltaTime = maxTick;
					ev->GlobalTick = maxTick;
					ev->status = 0x2f;
					ev->Data = gcnew array<Byte>(0);
					timeline->smf->Tracks[0]->Events->Add(ev);

					//Ȃ̒̐ݒ
					timeline->smf->MaxTick = maxTick;

					ShowMIDIData();
					ShowTimeLine(true);
					this->Show();
					this->Activate();

					if (config->Window->MDIChildMaximized) {
						frmTimeLine->WindowState = System::Windows::Forms::FormWindowState::Maximized;
					} else {
						frmTimeLine->WindowState = System::Windows::Forms::FormWindowState::Normal;
					}

					//AhDobt@̏
					undoBuffer = gcnew Editor::UndoBuffer();
					UndoToolUpdate();

					menuItemShowMIDIData->Enabled = true;
					menuItemShowTimeLine->Enabled = true;
					menuItemSaveAsProject->Enabled = true;
					menuItemSaveProject->Enabled = true;
				} else {
					menuItemShowMIDIData->Enabled = menuItemShowMIDIDataEnabled_bak;
					menuItemShowTimeLine->Enabled = menuItemShowTimeLineEnabled_bak;
					menuItemSaveAsProject->Enabled = menuItemSaveAsProjectEnabled_bak;
					menuItemSaveProject->Enabled = menuItemSaveProjectEnabled_bak;
				}
				//EBhEɉBĂ܂̉̑΍
				ShowMe();
			}
		}

	public:
		System::Void ShowMe() {//܂EBhEOɕ\ȂƂɂsĂ݂B
			this->TopMost = true;
			this->TopMost = false;
		}

	private:
		System::Void menuItemSaveProject_Click(System::Object^  sender, System::EventArgs^  e) {//vWFNg㏑ۑ
			SaveProject();
		}

	private:
		System::Void menuItemSaveAsProject_Click(System::Object^  sender, System::EventArgs^  e) {//OăvWFNg̕ۑ
			SaveAsProject();
		}

	private:
		bool SaveProject() {//vWFNgۑ(߂l=false=ۑsȂ)
			bool ret = false;

			if (ProjectFileName == nullptr) {
				ret = SaveAsProject();
			} else {
				DoSaveProject();
				ret = true;
			}

			return ret;
		}

	private:
		bool SaveAsProject() {//OăvWFNgۑ(߂l=false=ۑsȂ)
			bool ret = false;

			saveFileDialog1->InitialDirectory = config->Path->Project;
			saveFileDialog1->Filter = "Metronome Motion Maker Project|*.mprj|ׂẴt@C|*.*";
			saveFileDialog1->Title = "vWFNg̕ۑ";
			saveFileDialog1->FileName = "";
			if(saveFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::OK) {
				ProjectFileName = saveFileDialog1->FileName;
				this->Text = "Metronome Motion Maker - " + ProjectFileName;
				DoSaveProject();
				ret = true;
			}

			return ret;
		}

	private:
		System::Void DoSaveProject() {//vWFNgۑ
			this->Cursor = Cursors::WaitCursor;

			StreamWriter^ sw = gcnew StreamWriter(ProjectFileName, false, Encoding::GetEncoding("Shift_JIS"));

			sw->WriteLine("<Format Name=\"Metronome Motion Maker Project\" Version=\"1.2\"/>");
			
#ifdef _DEBUG

			sw->WriteLine("<Debug>");

			//qύXe[ȕoB
			sw->WriteLine("  <BeatChanges>");
			for (int i = 0; i < timeline->smf->BeatChanges->Count; i++) {
				SMF::BeatChange^ bc = safe_cast<SMF::BeatChange^>(timeline->smf->BeatChanges[i]);
				sw->WriteLine("    <BeatChange Beat=\"{0}/{1}\" GlobalTick=\"{2}\" Measure=\"{3}\"/>",
								bc->BeatInfo->nn, bc->BeatInfo->dd, bc->Tick, bc->Measure);
			}
			sw->WriteLine("  </BeatChanges>");

			//e|`FWe[ȕo
			sw->WriteLine("  <TempoChanges>");
			for (int i = 0; i < timeline->smf->TempoChanges->Count; i++) {
				SMF::TempoChange^ tc = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i]);
				sw->WriteLine("    <TempoChange Tempo=\"{0}\" Track=\"{1}\" GlobalTick=\"{2}\" Frame=\"{3}\"/>",
								tc->Tempo, tc->Track, tc->Tick, tc->Frame);
			}
			sw->WriteLine("  </TempoChanges>");

			sw->WriteLine("</Debug>");

#endif

			sw->WriteLine("<TimeLine Scale=\"{0}\">", timeline->tickScale);
			
			sw->WriteLine("  <SMF Name=\"{0}\">", timeline->smf->Filename);
			/* (20100419)́AȒύXMIDICxge[uύX̂ŁAǍMIDICxg璊oB
			sw->WriteLine("    <MaxTick>{0}</MaxTick>", timeline->smf->MaxTick);
			*/
			sw->WriteLine("    <Header Format=\"{0}\" Tracks=\"{1}\" DeltaTime=\"{2}\"/>",
															timeline->smf->Header.Format,
															timeline->smf->Header.Tracks,
															timeline->smf->Header.DeltaTime);
			for (int i = 0; i < timeline->smf->Header.Tracks; i++) {
				sw->WriteLine("    <Track Number=\"{0}\">", i);
				for (int j = 0; j < timeline->smf->Tracks[i]->Events->Count; j++) {
					SMF::Event^ ev = safe_cast<SMF::Event^>(timeline->smf->Tracks[i]->Events[j]);
					sw->WriteLine("      <Event Tick=\"{0}\" Status=\"{1,2:X2}\">{2}</Event>",
										ev->GlobalTick, ev->status, timeline->smf->ComposeHexDump(ev->Data));//Cxg͕ۑsv
				}
				sw->WriteLine("    </Track>");
			}
			sw->WriteLine("  </SMF>");

			for (int i = 0; i < timeline->Models->Count; i++) {
				Model^ model = safe_cast<Model^>(timeline->Models[i]);
				sw->WriteLine("  <Model Name=\"{0}\">", model->Name->ToString());
				sw->WriteLine("    <Rectangle Left=\"{0}\" Top=\"{1}\" Width=\"{2}\" Height=\"{3}\"/>",
												model->Left, model->Top, model->Width, model->Height);
				for (int j = 0; j < model->Patterns->Count; j++) {
					Pattern^ pattern = safe_cast<Pattern^>(model->Patterns[j]);
					sw->WriteLine("    <Pattern Type=\"{0}\" NoLength=\"{1}\" Repeat=\"{2}\">",
												(int)pattern->Type, pattern->NoLength, pattern->Repeat);
					sw->WriteLine("      <Rectangle Left=\"{0}\" Top=\"{1}\" Width=\"{2}\" Height=\"{3}\"/>",
													pattern->Left, pattern->Top, pattern->Width, pattern->Height);
					sw->WriteLine("      <Begin GlobalTick=\"{0}\" ShiftTick=\"{1}\" ShiftFrame=\"{2}\" BeatInfo=\"{3},{4},{5},{6}\"/>",
											pattern->Begin->GlobalTick, pattern->Begin->ShiftTick, pattern->Begin->ShiftFrame,
											pattern->Begin->BeatInfo->nn, pattern->Begin->BeatInfo->dd,
											pattern->Begin->BeatInfo->cc, pattern->Begin->BeatInfo->bb);
					sw->WriteLine("      <End GlobalTick=\"{0}\" ShiftTick=\"{1}\" ShiftFrame=\"{2}\" BeatInfo=\"{3},{4},{5},{6}\"/>",
											pattern->End->GlobalTick, pattern->End->ShiftTick, pattern->End->ShiftFrame,
											pattern->End->BeatInfo->nn, pattern->End->BeatInfo->dd,
											pattern->End->BeatInfo->cc, pattern->End->BeatInfo->bb);
					sw->WriteLine("      <Step Measure=\"{0}\" Beat=\"{1}\" Tick=\"{2}\"/>",
											pattern->Step->Measure, pattern->Step->Beat, pattern->Step->Tick,
											pattern->Step->ShiftTick, pattern->Step->ShiftFrame,
											pattern->Step->BeatInfo->nn, pattern->Step->BeatInfo->dd,
											pattern->Step->BeatInfo->cc, pattern->Step->BeatInfo->bb);
					if (pattern->Type == Patterns::POSE) {
						sw->WriteLine("      <VPD Name=\"{0}\">", pattern->vpd->FileName);
						for (int k = 0; k < pattern->vpd->Poses->Count; k++) {
							MMD::Pose^ pose = safe_cast<MMD::Pose^>(pattern->vpd->Poses[k]);
							sw->WriteLine("        <Bone Name=\"" + pose->Name + "\" Trans=\"{0},{1},{2}\" Rot=\"{3},{4},{5},{6}\"/>",
												pose->Trans.X, pose->Trans.Y, pose->Trans.Z,
												pose->Rot.X, pose->Rot.Y, pose->Rot.Z, pose->Rot.W);
						}
						sw->WriteLine("      </VPD>");
					}
					sw->WriteLine("    </Pattern>");
				}
				sw->WriteLine("  </Model>");
			}

			sw->WriteLine("</TimeLine>");

			sw->Close();

			timeline->Changed = false;
			this->Text = "Metronome Motion Maker - " + ProjectFileName;
			this->Cursor = Cursors::Default;
		}

	private:
		System::Void menuItemOpenProject_Click(System::Object^  sender, System::EventArgs^  e) {//vWFNgt@CJ
			if (FileConfirmation()) {//f[^ύXmF
				Open_Project();
			}
		}

	private:
		bool FileConfirmation() {//uύX܂Bۑ܂Hv̊mF(true = ύXA邢́AύX̔j)
			bool ret = true;

			if (timeline != nullptr && timeline->Changed) {
				System::Windows::Forms::DialogResult result = MessageBox::Show("f[^ύXĂ܂B\nvWFNgۑ܂H",
													"mF", System::Windows::Forms::MessageBoxButtons::YesNoCancel);
				if (result == System::Windows::Forms::DialogResult::Yes) {//ۑ
					if (SaveProject()) {//ۑꍇ
						ret = true;
					} else {//ۑLZꍇ
						ret = false;
					}
				} else if (result == System::Windows::Forms::DialogResult::Cancel) {//ILZ
					ret = false;
				}// else if (result == No) {ۑɏ𑱍s}

			}

			return ret;
		}

	private:
		System::Void Open_Project() {//vWFNgt@Cǂݍ
			Open_Project(nullptr);
		}

	private:
		System::Void Open_Project(String^ filename) {//vWFNgt@Cǂݍ
			bool menuItemShowTimeLineEnabled_bak = menuItemShowTimeLine->Enabled;
			bool menuItemShowMIDIDataEnabled_bak = menuItemShowMIDIData->Enabled;
			bool menuItemSaveAsProjectEnabled_bak = menuItemSaveAsProject->Enabled;
			bool menuItemSaveProjectEnabled_bak = menuItemSaveProject->Enabled;
			menuItemSaveAsProject->Enabled = false;
			menuItemSaveProject->Enabled = false;
			menuItemShowMIDIData->Enabled = false;
			menuItemShowTimeLine->Enabled = false;

			if (filename == nullptr) {
				openFileDialog1->InitialDirectory = config->Path->Project;
				openFileDialog1->FileName = "";
				openFileDialog1->Filter = "Metronome Motion Maker Project|*.mprj|ׂẴt@C|*.*";
				openFileDialog1->Title = "vWFNg̓Ǎ";
			}
			if(filename != nullptr || openFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::OK) {
				this->Cursor = Cursors::WaitCursor;

				ProjectFileName = (filename == nullptr) ? openFileDialog1->FileName : filename;

				this->Text = "Metronome Motion Maker - " + ProjectFileName;
				
				if (ParseProject()) {//vWFNgt@Cf[^ǂݍށB
					//MIDIf[^EBhE̕\
					frmSMF->Close();
					ShowMIDIData();


					//^CCEBhE̕\
					frmTimeLine->Close();
					ShowTimeLine(false);

					if (config->Window->MDIChildMaximized) {
						frmTimeLine->WindowState = System::Windows::Forms::FormWindowState::Maximized;
					} else {
						frmTimeLine->WindowState = System::Windows::Forms::FormWindowState::Normal;
					}

					//AhDobt@̏
					undoBuffer = gcnew Editor::UndoBuffer();
					UndoToolUpdate();

					this->menuItemShowMIDIData->Enabled = true;
					this->menuItemShowTimeLine->Enabled = true;
					this->menuItemSaveAsProject->Enabled = true;
					this->menuItemSaveProject->Enabled = true;
					timeline->Changed = false;
				} else {
					this->menuItemShowMIDIData->Enabled = menuItemShowMIDIDataEnabled_bak;
					this->menuItemShowTimeLine->Enabled = menuItemShowTimeLineEnabled_bak;
					this->menuItemSaveAsProject->Enabled = menuItemSaveAsProjectEnabled_bak;
					this->menuItemSaveProject->Enabled = menuItemSaveProjectEnabled_bak;
				}

				this->SetStatusProgressBar(0);
				this->Cursor = Cursors::Default;
			} else {//vWFNgǍLZ
				this->menuItemShowMIDIData->Enabled = menuItemShowMIDIDataEnabled_bak;
				this->menuItemShowTimeLine->Enabled = menuItemShowTimeLineEnabled_bak;
				this->menuItemSaveAsProject->Enabled = menuItemSaveAsProjectEnabled_bak;
				this->menuItemSaveProject->Enabled = menuItemSaveProjectEnabled_bak;
			}

		}

	private:
		bool ParseProject() {//vWFNgt@Cf[^ǂݍށB
			bool ret = true;

			try {
				StreamReader^ din = gcnew StreamReader(ProjectFileName, Encoding::GetEncoding("Shift_JIS"));
				System::String^ str;

				try {
					//ԗǂgĂꂪ Perl Ȃ̂ŁA킩ɂ܂񂪐K\gēǂ݂܂Ă܂B

					//tH[}bgo[W
					Regex^ rxFormat = gcnew Regex("^\\s*<Format\\s+Name=\"(.+)\"\\s+Version=\"([0-9.]+)\"/>\\s*$");
					//^CCf[^Jn
					Regex^ rxBeginTimeLine = gcnew Regex("^\\s*<TimeLine\\s+Scale=\"([.0-9]+)\">\\s*$");
					//^CCf[^Jn
					Regex^ rxEndTimeLine = gcnew Regex("^\\s*</TimeLine>\\s*$");
					//SMFf[^Jn
					Regex^ rxBeginSMF = gcnew Regex("^\\s*<SMF\\s+Name=\"(.*)\">\\s*$");
					//SMFf[^I
					Regex^ rxEndSMF = gcnew Regex("^\\s*</SMF>\\s*$");
					//SMFf[^(MaxTick)
					Regex^ rxMaxTick = gcnew Regex("^\\s*<MaxTick>\\s*(\\d+)\\s*</MaxTick>\\s*$");
					//SMFwb_
					Regex^ rxSMFHeader = gcnew Regex("^\\s*<Header\\s+Format=\"(\\d+)\"\\s+Tracks=\"(\\d+)\"\\s+DeltaTime=\"(\\d+)\"/>\\s*$");
					//SMFgbNJn
					Regex^ rxBeginSMFTrack = gcnew Regex("^\\s*<Track\\s+Number=\"(\\d+)\">\\s*$");
					//SMFgbNI
					Regex^ rxEndSMFTrack = gcnew Regex("^\\s*</Track>\\s*$");
					//SMF Cxg
					Regex^ rxSMFEvent = gcnew Regex("^\\s*<Event\\s+Tick=\"(\\d+)\"\\s+Status=\"([0-9A-Fa-f]+)\">([^<]*)</Event>\\s*$");
					//fJn
					Regex^ rxBeginModel = gcnew Regex("^\\s*<Model\\s+Name=\"(.+)\">\\s*$");
					//fI
					Regex^ rxEndModel = gcnew Regex("^\\s*</Model>\\s*$");
					//f`Ep^[`
					Regex^ rxRectangle = gcnew Regex("^\\s*<Rectangle\\s+Left=\"(\\d+)\"\\s+Top=\"(\\d+)\"\\s+Width=\"(\\d+)\"\\s+Height=\"(\\d+)\"/>\\s*$");
					//p^[Jn
					Regex^ rxBeginPattern = gcnew Regex("^\\s*<(Motion|Pattern)\\s+Type=\"(\\d+)\"\\s+NoLength=\"(True|False)\"\\s+Repeat=\"(\\d+)\">\\s*$");
					//p^[I
					Regex^ rxEndPattern = gcnew Regex("^\\s*</(Motion|Pattern)>\\s*$");
					//p^[JnʒuEp^[Iʒu
					Regex^ rxPosition = gcnew Regex("^\\s*<(Begin|End)\\s+GlobalTick=\"(\\d+)\"\\s+ShiftTick=\"([-0-9]+)\"\\s+ShiftFrame=\"([-0-9]+)\"\\s+BeatInfo=\"(\\d+),(\\d+),(\\d+),(\\d+)\"/>");
					//p^[JԂԊu
					Regex^ rxStep = gcnew Regex("^\\s*<Step\\s+Measure=\"(\\d+)\"\\s+Beat=\"(\\d+)\"\\s+Tick=\"(\\d+)\"/>\\s*$");
					//|[Yf[^Jn
					Regex^ rxBeginVPD = gcnew Regex("^\\s*<VPD\\s+Name=\"(.+)\">\\s*$");
					//|[Yf[^I
					Regex^ rxEndVPD = gcnew Regex("^\\s*</VPD>\\s*$");
					//|[Ỹ{[̃f[^(VMD̕ԕt̃{[̃f[^Ƃ͋ʂ)
					Regex^ rxVPDBone = gcnew Regex("^\\s*<Bone\\s+Name=\"(.+)\"\\s+Trans=\"([.\\-0-9]+),([.\\-0-9]+),([.\\-0-9]+)\"\\s+Rot=\"([.\\-0-9]+),([.\\-0-9]+),([.\\-0-9]+),([.\\-0-9]+)\"/>\\s*$");


					//Ƃ肠AG[`FbNƂ܂薳̕ŁB
					//(ʂۂŗȂxɃ`FbN)

					bool format_ok = false;
					if ((str = din->ReadLine()) != nullptr) {//1s
						if (rxFormat->IsMatch(str)) {//t@CtH[}bg
							MatchCollection^ matches = rxFormat->Matches(str);
							String^ format_name = matches[0]->Groups[1]->Captures[0]->Value;
							String^ format_version = matches[0]->Groups[2]->Captures[0]->Value;
							if (format_name == "Metronome Motion Maker Project" && (format_version == "1.0" || format_version == "1.2")) {
								format_ok = true;
							}
						}
					}
					if (!format_ok) {
						throw(safe_cast<String^>("t@CtH[}bgႢ܂B(1)"));
					}

					timeline = nullptr;
					SMF::Track^ track = nullptr;
					int t;//gbNԍ
					Model^ model = nullptr;
					Pattern^ pattern = nullptr;
					String^ beginPatternTag = nullptr;//p^[̃^O(Motion ܂ Pattern)
					MMD::VPD::Item^ vpd = nullptr;
					int max_tick = 0;
					int max_tr = 0;
					int model_count = 0;
					int file_max_tick = 0;

					while ((str = din->ReadLine()) != nullptr) {
						if (rxBeginTimeLine->IsMatch(str)) {//^CCJn
							if (timeline == nullptr) {
								MatchCollection^ matches = rxBeginTimeLine->Matches(str);
								timeline = gcnew TimeLine();
								timeline->tickScale = Double::Parse(matches[0]->Groups[1]->Captures[0]->Value);
							} else {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(2)"));
							}
						} else if (rxEndTimeLine->IsMatch(str)) {//^CCI
							if (timeline == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(3)"));
							}
						} else if (rxBeginSMF->IsMatch(str)) {//SMFf[^Jn
							if (timeline == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(4)"));
							} else {
								if (timeline->smf == nullptr) {
									MatchCollection^ matches = rxBeginSMF->Matches(str);
									timeline->smf = gcnew SMF::File();
									timeline->smf->Filename = matches[0]->Groups[1]->Captures[0]->Value;
								} else {
									throw(safe_cast<String^>("t@CtH[}bgႢ܂B(4)"));
								}
							}
						} else if (rxEndSMF->IsMatch(str)) {//SMFf[^I
							if (timeline == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(4)"));
							} else {
								if (timeline->smf == nullptr) {
									throw(safe_cast<String^>("t@CtH[}bgႢ܂B(5)"));
								} else {
									if (file_max_tick > 0) {//<MaxTick>`</MaxTick>Őݒ肳ĂƂ
										max_tick = file_max_tick;
										max_tr = 0;
									}

									//ԍŌ̃f[^
									SMF::TempoChange^ tc = gcnew SMF::TempoChange();
									tc->Tick = max_tick;
									tc->Track = max_tr;
									tc->Tempo = safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[timeline->smf->TempoChanges->Count - 1])->Tempo;
									timeline->smf->TempoChanges->Add(tc);

									timeline->smf->MaxTick = max_tick;
									/* MaxTickւ̃ZbgɌvZB
									//e|Ƀt[ǉB
									timeline->smf->CalcFrameAtTempoTable();
									*/

									//qύXe[ȕ߂̌vZ
									timeline->smf->CalcMeasureAtBeatTable();
								}
							}
						} else if (rxMaxTick->IsMatch(str)) {//SMFf[^(MaxTick)
							if (timeline == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(4)"));
							} else {
								if (timeline->smf == nullptr) {
									throw(safe_cast<String^>("t@CtH[}bgႢ܂B(5)"));
								} else {
									MatchCollection^ matches = rxMaxTick->Matches(str);
									file_max_tick = Int32::Parse(matches[0]->Groups[1]->Captures[0]->Value);
								}
							}
						} else if (rxSMFHeader->IsMatch(str)) {//SMFwb_[
							if (timeline == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(4)"));
							} else {
								if (timeline->smf == nullptr) {
									throw(safe_cast<String^>("t@CtH[}bgႢ܂B(6)"));
								} else {
									MatchCollection^ matches = rxSMFHeader->Matches(str);
									timeline->smf->Header.Format = Int32::Parse(matches[0]->Groups[1]->Captures[0]->Value);
									timeline->smf->Header.Tracks = Int32::Parse(matches[0]->Groups[2]->Captures[0]->Value);
									timeline->smf->Header.DeltaTime = Int32::Parse(matches[0]->Groups[3]->Captures[0]->Value);
									timeline->smf->Tracks = gcnew array<SMF::Track^>(timeline->smf->Header.Tracks);
								}
							}
						} else if (rxBeginSMFTrack->IsMatch(str)) {//SMFgbNJn
							if (timeline == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(4)"));
							} else {
								if (timeline->smf == nullptr || timeline->smf->Tracks == nullptr || track != nullptr) {
									throw(safe_cast<String^>("t@CtH[}bgႢ܂B(7)"));
								} else {
									MatchCollection^ matches = rxBeginSMFTrack->Matches(str);
									t = Int32::Parse(matches[0]->Groups[1]->Captures[0]->Value);
									if (t < timeline->smf->Header.Tracks) {
										timeline->smf->Tracks[t] = gcnew SMF::Track();
										track = timeline->smf->Tracks[t];
									} else {
										throw(safe_cast<String^>("t@CtH[}bgႢ܂B(8)"));
									}
								}
							}
						} else if (rxEndSMFTrack->IsMatch(str)) {//SMFgbNI
							if (track == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(9)"));
							} else {
								track = nullptr;
							}
						} else if (rxSMFEvent->IsMatch(str)) {//SMFCxg
							if (track == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(10)"));
							} else {
								MatchCollection^ matches = rxSMFEvent->Matches(str);
								SMF::Event^ ev = gcnew SMF::Event();
								ev->GlobalTick = Int32::Parse(matches[0]->Groups[1]->Captures[0]->Value);
								if (ev->GlobalTick > max_tick) {
									max_tick = ev->GlobalTick;
									max_tr = t;
								}
								ev->status = Byte::Parse(matches[0]->Groups[2]->Captures[0]->Value,
														System::Globalization::NumberStyles::HexNumber);
								array<String^>^ strData = matches[0]->Groups[3]->Captures[0]->Value->Split(' ');
								if (strData->Length == 1 && strData[0] == "") {//f[^ȂCxĝƂ
									ev->Data = gcnew array<Byte>(0);//̔z쐬
								} else {
									ev->Data = gcnew array<Byte>(strData->Length);
									for (int i = 0; i < strData->Length; i++) {
										ev->Data[i] = Byte::Parse(strData[i], System::Globalization::NumberStyles::HexNumber);
									}
								}

								//SMF::File::Open() ̃Rs[B(֐قȂ\)
								if (ev->status == 0x51) {//e|f[^TempoChangesRNVɊi[B
									
									//̂̃f[^Ae|f[^gbNɂ܂Ăꍇ̑Ώ
									int c = timeline->smf->TempoChanges->Count;
									for (int i = 0; i < c; i++) {
										if (safe_cast<SMF::TempoChange^>(timeline->smf->TempoChanges[i])->Tick > ev->GlobalTick) {//tick傫ꍇ
											//̑OinsertB
											SMF::TempoChange^ tc = gcnew SMF::TempoChange();
											tc->Tick = ev->GlobalTick;
											tc->Track = t;
											tc->Tempo = SMF::File::CalcTempo(ev->Data);
											timeline->smf->TempoChanges->Insert(i, tc);
											break;
										}
									}
									if (c == timeline->smf->TempoChanges->Count) {//L[vinsertȂꍇ
										//ǉ
										SMF::TempoChange^ tc = gcnew SMF::TempoChange();
										tc->Tick = ev->GlobalTick;
										tc->Track = t;
										tc->Tempo = SMF::File::CalcTempo(ev->Data);
										timeline->smf->TempoChanges->Add(tc);
									}
								}

								if (ev->status == 0x58) {//qύXBeatChangesRNVɊi[B
									SMF::Beat^ beat = gcnew SMF::Beat();
									beat->SetBeat(ev->Data[0], 1 << ev->Data[1], ev->Data[2], ev->Data[3]);
									timeline->smf->BeatChanges->Add(gcnew SMF::BeatChange(beat, ev->GlobalTick));
								}

								track->Events->Add(ev);
							}
						} else if (rxBeginModel->IsMatch(str)) {//fJn
							if (model == nullptr) {
								model_count++;
								MatchCollection^ matches = rxBeginModel->Matches(str);
								model = gcnew Model();
								model->Name = gcnew MMD::String(matches[0]->Groups[1]->Captures[0]->Value);
							} else {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(11)"));
							}
						} else if (rxEndModel->IsMatch(str)) {//fI
							if (model == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(12)"));
							} else {
								if (model_count > 1) {//gm[(1ڂ̃f)͒ǉȂB
									timeline->Models->Add(model);
								}
								model = nullptr;
							}
						} else if (rxRectangle->IsMatch(str)) {//f`Ep^[`
							MatchCollection^ matches = rxRectangle->Matches(str);
							if (pattern != nullptr) {//p^[ǂݍݒ̂Ƃ
								pattern->Top = Int32::Parse(matches[0]->Groups[2]->Captures[0]->Value);
								pattern->Height = Int32::Parse(matches[0]->Groups[4]->Captures[0]->Value);
							} else if (model != nullptr) {//fǂݍݒ̂Ƃ
								model->Left = Int32::Parse(matches[0]->Groups[1]->Captures[0]->Value);
								model->Top = Int32::Parse(matches[0]->Groups[2]->Captures[0]->Value);
								model->Width = Int32::Parse(matches[0]->Groups[3]->Captures[0]->Value);
								model->Height = Int32::Parse(matches[0]->Groups[4]->Captures[0]->Value);
							} else {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(13)"));
							}
						} else if (rxBeginPattern->IsMatch(str)) {//p^[Jn
							if (pattern == nullptr) {
								MatchCollection^ matches = rxBeginPattern->Matches(str);
								beginPatternTag = matches[0]->Groups[1]->Captures[0]->Value;
								pattern = gcnew Pattern();
								pattern->timeline = timeline;
								pattern->Type = (MetMotMk::Patterns::Type)Int32::Parse(matches[0]->Groups[2]->Captures[0]->Value);
								pattern->NoLength = matches[0]->Groups[3]->Captures[0]->Value == "True";
								pattern->Repeat = Int32::Parse(matches[0]->Groups[4]->Captures[0]->Value);
							} else {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(14)"));
							}
						} else if (rxEndPattern->IsMatch(str)) {//p^[I
							if (pattern == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(15)"));
							} else {
								MatchCollection^ matches = rxEndPattern->Matches(str);
								if (beginPatternTag != matches[0]->Groups[1]->Captures[0]->Value) {
									//p^[̊Jñ^OƏĨ^OHĂꍇ
									throw(safe_cast<String^>("t@CtH[}bgႢ܂B(15-2)"));
								}
								model->AddPattern(pattern);
								pattern = nullptr;
							}
						} else if (rxPosition->IsMatch(str)) {//p^[JnʒuEp^[Iʒu
							if (pattern == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(16)"));
							} else {
								MatchCollection^ matches = rxPosition->Matches(str);
								SMF::Position^ position = gcnew SMF::Position(timeline->smf);
								position->GlobalTick = Int32::Parse(matches[0]->Groups[2]->Captures[0]->Value);
								position->ShiftTick = Int32::Parse(matches[0]->Groups[3]->Captures[0]->Value);
								position->ShiftFrame = Int32::Parse(matches[0]->Groups[4]->Captures[0]->Value);
								/* q́AGlobalTickݒ莞ɎŌvẐŁAvWFNgt@Cւ̏o͕svȉ\
								position->BeatInfo->nn = Int32::Parse(matches[0]->Groups[5]->Captures[0]->Value);
								position->BeatInfo->dd = Int32::Parse(matches[0]->Groups[6]->Captures[0]->Value);
								position->BeatInfo->cc = Int32::Parse(matches[0]->Groups[7]->Captures[0]->Value);
								position->BeatInfo->bb = Int32::Parse(matches[0]->Groups[8]->Captures[0]->Value);
								*/
								if (matches[0]->Groups[1]->Captures[0]->Value == "Begin") {//Jnʒu
									pattern->Begin = position;
								} else {//Iʒu
									pattern->End = position;
								}
							}
						} else if (rxStep->IsMatch(str)) {//p^[JԂԊu
							if (pattern == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(17)"));
							} else {
								MatchCollection^ matches = rxStep->Matches(str);
								pattern->Step = gcnew SMF::Position();
								pattern->Step->Measure = Int32::Parse(matches[0]->Groups[1]->Captures[0]->Value);
								pattern->Step->Beat = Int32::Parse(matches[0]->Groups[2]->Captures[0]->Value);
								pattern->Step->Tick = Int32::Parse(matches[0]->Groups[3]->Captures[0]->Value);
							}
						} else if (rxBeginVPD->IsMatch(str)) {//|[Yf[^Jn
							if (pattern == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(18)"));
							} else {
								if (vpd == nullptr) {
									MatchCollection^ matches = rxBeginVPD->Matches(str);
									vpd = gcnew MMD::VPD::Item();
									vpd->FileName = matches[0]->Groups[1]->Captures[0]->Value;
								} else {
									throw(safe_cast<String^>("t@CtH[}bgႢ܂B(19)"));
								}
							}
						} else if (rxEndVPD->IsMatch(str)) {//|[Yf[^I
							if (vpd == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(20)"));
							} else {
								pattern->vpd = vpd;
								vpd = nullptr;
							}
						} else if (rxVPDBone->IsMatch(str)) {//|[Ỹ{[̃f[^
							if (vpd == nullptr) {
								throw(safe_cast<String^>("t@CtH[}bgႢ܂B(21)"));
							} else {
								MatchCollection^ matches = rxVPDBone->Matches(str);
								MMD::Pose^ pose = gcnew MMD::Pose();
								pose->Name = gcnew MMD::String(matches[0]->Groups[1]->Captures[0]->Value);
								pose->Trans.X = Single::Parse(matches[0]->Groups[2]->Captures[0]->Value);
								pose->Trans.Y = Single::Parse(matches[0]->Groups[3]->Captures[0]->Value);
								pose->Trans.Z = Single::Parse(matches[0]->Groups[4]->Captures[0]->Value);
								pose->Rot.X = Single::Parse(matches[0]->Groups[5]->Captures[0]->Value);
								pose->Rot.Y = Single::Parse(matches[0]->Groups[6]->Captures[0]->Value);
								pose->Rot.Z = Single::Parse(matches[0]->Groups[7]->Captures[0]->Value);
								pose->Rot.W = Single::Parse(matches[0]->Groups[8]->Captures[0]->Value);
								vpd->Poses->Add(pose);
							}
						}

					}
					ret = true;
				} catch (System::String^ strError) {
					MessageBox::Show(strError, "error");
					ret = false;
				}
				din->Close();
			} catch (Exception^ e) {
				ret = false;
				if (dynamic_cast<FileNotFoundException^>(e))
					MessageBox::Show("t@C܂B\n" + dynamic_cast<FileNotFoundException^>(e)->FileName, "error");
				else
					MessageBox::Show("t@CǍɖ肪܂B\n" + e->ToString(), "error");
			}

			return ret;
		}

	public:
		System::Void OnDataChanged() {//f[^ɕύXƂɃtH[̃LvVύX
			this->Text = "Metronome Motion Maker - " + ((ProjectFileName == nullptr) ? "VKvWFNg" : ProjectFileName) + "*";
		}

	private:
		System::Void Form1_KeyDown(System::Object^  sender, System::Windows::Forms::KeyEventArgs^  e) {//V[gJbgL[̏
			if (e->Control && e->KeyCode == Keys::S) {//Ctrl+S
				SaveProject();//vWFNg̏㏑ۑ
			} else if (e->Control && e->KeyCode == Keys::Z) {//Ctrl+Z(ɖ߂)
				Undo();
			} else if (e->Control && e->KeyCode == Keys::Y) {//Ctrl+Y(蒼)
				Redo();
			}
		}

	public:
		System::Void SetStatusMessage(String^ str) {//Xe[^Xo[̃bZ[W֕\
			this->statusMessage->Text = str;
			this->statusBar->Refresh();
		}

	public:
		System::Void SetStatusProgressBarMax(int max) {//Xe[^Xo[̃vOXo[̍őlݒ
			this->statusProgressBar->Maximum = max;
			this->statusBar->Refresh();
		}

	public:
		System::Void SetStatusProgressBar(int bar) {//Xe[^Xo[̃vOXo[ɒlݒ
			//System::Diagnostics::Debug::WriteLineIf(this->statusProgressBar->Value != bar, System::String::Format("bar={0},value={1}/{2}", bar, this->statusProgressBar->Value, this->statusProgressBar->Maximum));
			this->statusProgressBar->Value = bar;
			this->statusBar->Refresh();
		}

	public:
		System::Void SetStatusPosition(String^ str) {//Xe[^Xo[̎Ԉʒu֕\
			this->statusCursorPos->Text = str;
			this->statusBar->Refresh();
		}

	private:
		System::Void menuItemToolOption_Click(System::Object^  sender, System::EventArgs^  e) {//IvVݒ
			OptionDialog^ dlg = gcnew OptionDialog();

			dlg->config = config->Copy();
			if (dlg->ShowDialog(this) == System::Windows::Forms::DialogResult::OK) {
				config = dlg->config->Copy();
				if (config->Window->Pos == Option::WindowStates::PRESENT) {
					config->Window->Left = this->Left;
					config->Window->Top = this->Top;
					config->Window->Pos = Option::WindowStates::SET;
				}
				if (config->Window->Size == Option::WindowStates::DEFAULT) {
					config->Window->Width = 800;
					config->Window->Height = 600;
				} else if (config->Window->Size == Option::WindowStates::PRESENT) {
					config->Window->Width = this->Width;
					config->Window->Height = this->Height;
					config->Window->Size = Option::WindowStates::SET;
				}
				//`FbN̍XV
				config->Version->UpdateNextCheckDate();
				config->Save(ConfigFileName);
				if (frmTimeLine != nullptr && frmTimeLine->Created) {
					frmTimeLine->config = config;
					UpdateTimeLine();
				}
			}
		}

	private:
		System::Void menuItemCheckVersion_Click(System::Object^  sender, System::EventArgs^  e) {//ŐVo[W`FbN
			CheckVersion(true);
		}

	private:
		System::Void CheckVersion(bool showOk) {//ŐVo[W`FbN
			//showOk=true=uŐVłv\B(j[ŐVo[W`FbNI񂾂Ƃ)
			//       false=uŐVłv͕\ȂB(NɎ`FbNƂ)
			this->Cursor = System::Windows::Forms::Cursors::WaitCursor;

			SetStatusMessage("ŐVo[WmFĂ܂B");

			MetMotMk::Version^ version = gcnew MetMotMk::Version();

			System::Net::HttpWebRequest^ request = nullptr;
			System::Net::HttpWebResponse^ response = nullptr;
			Stream^ receiveStream = nullptr;
			StreamReader^ rs = nullptr;

			try {
				request = dynamic_cast<System::Net::HttpWebRequest^>(System::Net::WebRequest::Create(version->URL));
				switch (config->Version->ProxySetting) {
				case Option::Proxy::NONE:
					request->Proxy = nullptr;
					break;
				case Option::Proxy::AUTO:
					request->Proxy = System::Net::WebRequest::DefaultWebProxy;
					break;
				case Option::Proxy::MANUAL:
					request->Proxy = gcnew System::Net::WebProxy(config->Version->ProxyHost, config->Version->ProxyPort);
					break;
				}

				response = dynamic_cast<System::Net::HttpWebResponse^>(request->GetResponse());

				receiveStream = response->GetResponseStream();

				rs = gcnew StreamReader(receiveStream);

				int serial = Int32::Parse(rs->ReadLine());

				if (serial > version->Serial) {
					String^ zip = rs->ReadLine();

					MetMotMk::Version^ new_version = gcnew MetMotMk::Version();
					new_version->Serial = serial;

					NewVersionDialog^ dlg = gcnew NewVersionDialog();
					dlg->version = new_version->ToString();
					dlg->zip = zip;

					dlg->ShowDialog();
				} else {
					if (showOk) {//uŐVłv\ƂB
						MessageBox::Show("ŐVo[WgpłB", "Metronome Motion Maker");
					}
				}

				//o[W`FbN̍XV
				config->Version->LastCheckDate = DateTime::Now;
				//`FbN̍XV
				config->Version->UpdateNextCheckDate();
				//ݒۑ
				config->Save(ConfigFileName);
			} catch (System::Net::WebException ^e) {
				MessageBox::Show(e->Message, "G[");
			}

			if (response != nullptr) {
				response->Close();
			}
			if (rs != nullptr) {
				rs->Close();
			}

			SetStatusMessage("");

			this->Cursor = System::Windows::Forms::Cursors::Default;

		}

	private:
		System::Void Form1_Shown(System::Object^  sender, System::EventArgs^  e) {
			//o[W`FbN
			DateTime date = DateTime::Now;
			if (config->Version->Frequency == Option::VersionCheck::EVERY_TIME
						|| (config->Version->Frequency == Option::VersionCheck::EVERY_DAY
						|| config->Version->Frequency == Option::VersionCheck::EVERY_WEEK
						|| config->Version->Frequency == Option::VersionCheck::EVERY_MONTH)
								&& date >= config->Version->NextCheckDate) {
				CheckVersion(false);//ŐV̏ꍇ͉\ȂB
			}

			//PvWFNgt@CƂēǂݍށB
			if (Args->Length > 0) {
				Open_Project(Args[0]);
			}
		}

	public:
		System::Void MergeToolbar(ToolStrip^ toolbar) {//c[o[̌
			ToolStripManager::Merge(toolbar, toolMain);
		}

	public:
		System::Void RevertMergeToolbar(ToolStrip^ toolbar) {//c[o[̌̉
			ToolStripManager::RevertMerge(toolMain, toolbar);
		}

	private:
		System::Void menuItemManual_Click(System::Object^  sender, System::EventArgs^  e) {
			ProcessStartInfo^ sInfo = gcnew ProcessStartInfo("http://yuao.o.oo7.jp/doc/MetMotMk/");
			Process::Start(sInfo);
		}

	public:
		System::Void Exec(Editor::Operation^ operation) {//ҏW̎sƃAhDobt@ւ̒ǉ
			timeline->Changed = true;
			operation->Do();
			undoBuffer->Add(operation);
			UndoToolUpdate();
		}

	public:
		System::Void Undo() {//ɖ߂
			undoBuffer->Undo();
			UndoToolUpdate();
		}

	public:
		System::Void Redo() {//ɖ߂蒼
			undoBuffer->Redo();
			UndoToolUpdate();
		}

	public:
		System::Void UndoToolUpdate() {//AhDEhD̃j[Ec[o[̗LE̍XV
			System::String^ str;

			//ɖ߂
			str = undoBuffer->GetUndoName();
			if (str == nullptr) {//AhDł鑀삪ȂƂ
				this->menuItemEditUndo->Text = "ɖ߂";
				this->menuItemEditUndo->Enabled = false;
				this->toolBtnUndo->ToolTipText = "ɖ߂";
				this->toolBtnUndo->Enabled = false;
			} else {//AhDł鑀삪Ƃ
				this->menuItemEditUndo->Text = "ɖ߂(" + str + ")";
				this->menuItemEditUndo->Enabled = true;
				this->toolBtnUndo->ToolTipText = "ɖ߂(" + str + ")";
				this->toolBtnUndo->Enabled = true;
			}

			//蒼
			str = undoBuffer->GetRedoName();
			if (str == nullptr) {//hDł鑀삪ȂƂ
				this->menuItemEditRedo->Text = "蒼";
				this->menuItemEditRedo->Enabled = false;
				this->toolBtnRedo->ToolTipText = "蒼";
				this->toolBtnRedo->Enabled = false;
			} else {//hDł鑀삪Ƃ
				this->menuItemEditRedo->Text = "蒼(" + str + ")";
				this->menuItemEditRedo->Enabled = true;
				this->toolBtnRedo->ToolTipText = "蒼(" + str + ")";
				this->toolBtnRedo->Enabled = true;
			}
		}

	private:
		System::Void toolBtnUndo_Click(System::Object^  sender, System::EventArgs^  e) {
			Undo();
		}

	private:
		System::Void toolBtnRedo_Click(System::Object^  sender, System::EventArgs^  e) {
			Redo();
		}
	
	private:
		System::Void menuItemEditUndo_Click(System::Object^  sender, System::EventArgs^  e) {
			Undo();
		}

	private:
		System::Void menuItemEditRedo_Click(System::Object^  sender, System::EventArgs^  e) {
			Redo();
		}

	private:
		System::Void menuItemEdit_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			if (frmTimeLine != nullptr && frmTimeLine->Created) {
				frmTimeLine->UpdateEditMenu();
			}
			PanScrollStop();
		}

	public:
		System::Void InsertTempo(int track, int index, SMF::TempoChange^ tc) {//e|̑}
			frmSMF->InsertTempo(track, index, tc);
		}

	public:
		System::Void ReplaceTempo(int track, int index, SMF::TempoChange^ tc) {//e|̒u
			frmSMF->ReplaceTempo(track, index, tc);
		}

	public:
		System::Void InsertBeat(int track, int index, SMF::BeatChange^ bc) {//q̑}
			frmSMF->InsertBeat(track, index, bc);
		}

	public:
		System::Void AddBeat(int track, SMF::BeatChange^ bc) {//q̒ǉ
			frmSMF->AddBeat(track, bc);
		}

	public:
		System::Void ReplaceBeat(int track, int index, SMF::BeatChange^ bc) {//q̒u
			frmSMF->ReplaceBeat(track, index, bc);
		}

	public:
		System::Void PanScrollStop() {//pXN[̏I
			if (frmTimeLine != nullptr && frmTimeLine->Created) {
				frmTimeLine->PanScrollStop();
			}
		}

	private:
		System::Void menuStripMain_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void menuItemHelp_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void menuItemTool_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void menuItemWindow_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void menuItemView_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void menuItemFile_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void statusBar_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void toolMain_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void statusMessage_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void statusProgressBar_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void statusCursorPos_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void toolBtnUndo_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void toolBtnRedo_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void Form1_Resize(System::Object^  sender, System::EventArgs^  e) {
			PanScrollStop();
		}

	private:
		System::Void Form1_Move(System::Object^  sender, System::EventArgs^  e) {
			PanScrollStop();
		}
};
}

