#include "StdAfx.h"
#include "Option_Color.h"

namespace MetMotMk {

	namespace Option {

		Color::Color(void)
		{
			PatternColor^ color;

			Items = gcnew ArrayList();

			//|[Yp^[̐F
			color = gcnew PatternColor();
			color->Type = Patterns::POSE;
			color->FontColor = System::Drawing::Color::Black;
			color->ForeColor = System::Drawing::Color::FromArgb(0xff,0x80,0x80);
			color->BackColor = System::Drawing::Color::FromArgb(0xff,0xd0,0xd0);
			Items->Add(color);

			//[Vp^[̐F
			color = gcnew PatternColor();
			color->Type = Patterns::MOTION;
			color->FontColor = System::Drawing::Color::Black;
			color->ForeColor = System::Drawing::Color::FromArgb(0xf4,0xa2,0x3C);
			color->BackColor = System::Drawing::Color::FromArgb(0xff,0xe0,0x80);
			Items->Add(color);

			//p^[̐F
			color = gcnew PatternColor();
			color->Type = Patterns::CONTAINER;
			color->FontColor = System::Drawing::Color::Black;
			color->ForeColor = System::Drawing::Color::FromArgb(0xb0,0xb0,0xff);
			color->BackColor = System::Drawing::Color::FromArgb(0xe0,0xe0,0xff);
			Items->Add(color);

			//bvp^[̐F
			color = gcnew PatternColor();
			color->Type = Patterns::LIPSYNC;
			color->FontColor = System::Drawing::Color::Black;
			color->ForeColor = System::Drawing::Color::FromArgb(0xff,0xe0,0xe0);
			color->BackColor = System::Drawing::Color::FromArgb(0xff,0xf0,0xf0);
			Items->Add(color);

			//tp^[̐F
			color = gcnew PatternColor();
			color->Type = Patterns::MIDI;
			color->FontColor = System::Drawing::Color::Black;
			color->ForeColor = System::Drawing::Color::FromArgb(0x80,0xe0,0x80);
			color->BackColor = System::Drawing::Color::FromArgb(0xd0,0xff,0xd0);
			Items->Add(color);

			//V[gJbg̐F
			color = gcnew PatternColor();
			color->Type = Patterns::SHORTCUT;
			color->FontColor = System::Drawing::Color::Black;
			color->ForeColor = System::Drawing::Color::FromArgb(0xf0,0xe0,0xff);
			color->BackColor = System::Drawing::Color::FromArgb(0xf8,0xf0,0xff);
			Items->Add(color);

			//Rg̐F
			color = gcnew PatternColor();
			color->Type = Patterns::COMMENT;
			color->FontColor = System::Drawing::Color::Black;
			color->ForeColor = System::Drawing::Color::FromArgb(0xff,0xf0,0xe0);
			color->BackColor = System::Drawing::Color::FromArgb(0xff,0xf8,0xf0);
			Items->Add(color);

		}

		Color^ Color::Copy() {
			Color^ color = gcnew Color();

			for (int i = 0; i < Items->Count; i++) {
				PatternColor^ item = safe_cast<PatternColor^>(Items[i]);
				color->Items[i] = item->Copy();
			}

			return color;
		}

		PatternColor^ Color::GetPatternColor(Patterns::Type type) {//w肵p^[PatternColor擾B
			return safe_cast<PatternColor^>(Items[(int)type]);
		}

	}//Option

}//MetMotMk
