#include "StdAfx.h"
#include "Option_Config.h"

using namespace System::Text;

namespace MetMotMk {

	namespace Option {

		Config::Config(void)
		{
			this->Path = gcnew Option::Path();
			this->Edit = gcnew Option::Edit();
			this->Color = gcnew Option::Color();
			this->Window = gcnew Option::Window();
			this->Version = gcnew Option::Version();
		}

		Config^ Config::Copy() {
			Config^ config = gcnew Config();

			//õRs[
			config->Path = this->Path->Copy();
			config->Edit = this->Edit->Copy();
			config->Color = this->Color->Copy();
			config->Window = this->Window->Copy();
			config->Version = this->Version->Copy();

			return config;
		}

		System::Void Config::Save(String^ filename) {//IvVݒ̕ۑ
			try {

				StreamWriter^ sw = gcnew StreamWriter(filename, false, Encoding::GetEncoding("Shift_JIS"));

				sw->WriteLine("[PATH]");
				sw->WriteLine("PROJECT={0}", Path->Project);
				sw->WriteLine("PATTERN={0}", Path->Pattern);
				sw->WriteLine("MIDI={0}", Path->MIDI);
				sw->WriteLine("MMD_USERFILE={0}", Path->MMD_UserFile);
				sw->WriteLine("MMD_EXPLICIT_PATH={0}", Path->ExplicitPath);
				sw->WriteLine("MMD_POSE={0}", Path->MMD_Pose);
				sw->WriteLine("MMD_MOTION={0}", Path->MMD_Motion);
				sw->WriteLine("MMD_MODEL={0}", Path->MMD_Model);
				sw->WriteLine();

				sw->WriteLine("[EDIT]");
				sw->WriteLine("ON_GRID={0}", Edit->OnGrid);
				sw->WriteLine("GRID={0}", Edit->Grid);
				sw->WriteLine("GRID_CLICK_ON_LINE={0}", Edit->GridClickOnLine);
				sw->WriteLine("MODEL_HEIGHT={0}", Edit->DefaultModelHeight);
				sw->WriteLine("SHOW_MODEL={0}", Edit->ShowModel);
				sw->WriteLine("MODEL_NAME={0}", Edit->ModelName);
				sw->WriteLine("DND_SCROLL_WAIT={0}", Edit->DnDScrollWait);
				sw->WriteLine();

				sw->WriteLine("[COLOR]");
				sw->WriteLine("POSE_FONT={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::POSE)->FontColor.ToArgb());
				sw->WriteLine("POSE_FORE={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::POSE)->ForeColor.ToArgb());
				sw->WriteLine("POSE_BACK={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::POSE)->BackColor.ToArgb());
				sw->WriteLine("MOTION_FONT={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::MOTION)->FontColor.ToArgb());
				sw->WriteLine("MOTION_FORE={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::MOTION)->ForeColor.ToArgb());
				sw->WriteLine("MOTION_BACK={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::MOTION)->BackColor.ToArgb());
				sw->WriteLine("CONTAINER_FONT={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::CONTAINER)->FontColor.ToArgb());
				sw->WriteLine("CONTAINER_FORE={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::CONTAINER)->ForeColor.ToArgb());
				sw->WriteLine("CONTAINER_BACK={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::CONTAINER)->BackColor.ToArgb());
				sw->WriteLine("LIPSYNC_FONT={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::LIPSYNC)->FontColor.ToArgb());
				sw->WriteLine("LIPSYNC_FORE={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::LIPSYNC)->ForeColor.ToArgb());
				sw->WriteLine("LIPSYNC_BACK={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::LIPSYNC)->BackColor.ToArgb());
				sw->WriteLine("MIDI_FONT={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::MIDI)->FontColor.ToArgb());
				sw->WriteLine("MIDI_FORE={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::MIDI)->ForeColor.ToArgb());
				sw->WriteLine("MIDI_BACK={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::MIDI)->BackColor.ToArgb());
				sw->WriteLine("SHORTCUT_FONT={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::SHORTCUT)->FontColor.ToArgb());
				sw->WriteLine("SHORTCUT_FORE={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::SHORTCUT)->ForeColor.ToArgb());
				sw->WriteLine("SHORTCUT_BACK={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::SHORTCUT)->BackColor.ToArgb());
				sw->WriteLine("COMMENT_FONT={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::COMMENT)->FontColor.ToArgb());
				sw->WriteLine("COMMENT_FORE={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::COMMENT)->ForeColor.ToArgb());
				sw->WriteLine("COMMENT_BACK={0,6:X6}", 0xffffff & Color->GetPatternColor(Patterns::COMMENT)->BackColor.ToArgb());
				sw->WriteLine();

				sw->WriteLine("[WINDOW]");
				sw->WriteLine("POS_MODE={0}", (int)Window->Pos);
				sw->WriteLine("SIZE_MODE={0}", (int)Window->Size);
				sw->WriteLine("LEFT={0}", Window->Left);
				sw->WriteLine("TOP={0}", Window->Top);
				sw->WriteLine("WIDTH={0}", Window->Width);
				sw->WriteLine("HEIGHT={0}", Window->Height);
				sw->WriteLine("CHILD_MAXIMIZED={0}", Window->MDIChildMaximized);
				sw->WriteLine();

				sw->WriteLine("[VERSION]");
				sw->WriteLine("FREQUENCY={0}", (int)Version->Frequency);
				sw->WriteLine("NEXT_DAY_OF_WEEK={0}", (int)Version->NextDayOfWeek);
				sw->WriteLine("NEXT_DAY={0}", Version->NextDay);
				sw->WriteLine("LAST_CHECK={0}", Version->LastCheckDate);
				sw->WriteLine("NEXT_CHECK={0}", Version->NextCheckDate);
				sw->WriteLine("PROXY={0}", (int)Version->ProxySetting);
				sw->WriteLine("PROXY_HOST={0}", Version->ProxyHost);
				sw->WriteLine("PROXY_PORT={0}", Version->ProxyPort);
				sw->WriteLine();

				sw->Close();

			} catch (Exception^ e) {
				MessageBox::Show("MetMotMk.ini ۑɖ肪܂B\n" + e->ToString(), "error");
			}
		}

		System::Void Config::Open(String^ filename) {//IvVݒ̓Ǎ
			StreamReader^ din = nullptr;
			try {
				din = gcnew StreamReader(filename, Encoding::GetEncoding("Shift_JIS"));
				System::String^ str;

				//Rg
				Regex^ rxComment = gcnew Regex("^;");
				//ZNV
				Regex^ rxSection = gcnew Regex("^\\[([^\\]]+)\\]");
				//p[^
				Regex^ rxParam = gcnew Regex("^([^\\s=]+)\\s*=\\s*(.*)\\s*$");

				String^ section = nullptr;
				while ((str = din->ReadLine()) != nullptr) {

					if (rxComment->IsMatch(str)) {//Rg
						continue;//Ȃ
					} else if (rxSection->IsMatch(str)) {//ZNV
						MatchCollection^ matches = rxSection->Matches(str);
						section = matches[0]->Groups[1]->Captures[0]->Value->ToUpper();
					} else if (rxParam->IsMatch(str)) {//p[^
						if (section == nullptr) {
							throw(safe_cast<String^>("MetMotMk.ini ̃t@CtH[}bgႢ܂B"));
						} else {
							MatchCollection^ matches = rxParam->Matches(str);
							String^ key = matches[0]->Groups[1]->Captures[0]->Value->ToUpper();
							String^ value = matches[0]->Groups[2]->Captures[0]->Value;
							if (section == "PATH") {
								if (key == "PROJECT") {
									Path->Project = value;
								} else if (key == "PATTERN") {
									Path->Pattern = value;
								} else if (key == "MIDI") {
									Path->MIDI = value;
								} else if (key == "MMD_USERFILE") {
									Path->MMD_UserFile = value;
								} else if (key == "MMD_EXPLICIT_PATH") {
									Path->ExplicitPath = (value == "True");
								} else if (key == "MMD_POSE") {
									Path->MMD_Pose = value;
								} else if (key == "MMD_MOTION") {
									Path->MMD_Motion = value;
								} else if (key == "MMD_MODEL") {
									Path->MMD_Model = value;
								}
							} else if (section == "EDIT") {
								if (key == "ON_GRID") {
									Edit->OnGrid = (value == "True");
								} else if (key == "GRID") {
									Edit->Grid = Int32::Parse(value);
								} else if (key == "GRID_CLICK_ON_LINE") {
									Edit->GridClickOnLine = (value == "True");
								} else if (key == "SHOW_MODEL") {
									Edit->ShowModel = (value == "True");
								} else if (key == "MODEL_NAME") {
									Edit->ModelName = value;
								} else if (key == "MODEL_HEIGHT") {
									Edit->DefaultModelHeight = Int32::Parse(value);
								} else if (key == "DND_SCROLL_WAIT") {
									Edit->DnDScrollWait = Double::Parse(value);
								}
							} else if (section == "COLOR") {
								Patterns::Type fontType = Patterns::ALL;
								Patterns::Type foreType = Patterns::ALL;
								Patterns::Type backType = Patterns::ALL;

								if (key == "POSE_FONT") {
									fontType = Patterns::POSE;
								} else if (key == "POSE_FORE") {
									foreType = Patterns::POSE;
								} else if (key == "POSE_BACK") {
									backType = Patterns::POSE;
								} else if (key == "MOTION_FONT") {
									fontType = Patterns::MOTION;
								} else if (key == "MOTION_FORE") {
									foreType = Patterns::MOTION;
								} else if (key == "MOTION_BACK") {
									backType = Patterns::MOTION;
								} else if (key == "CONTAINER_FONT") {
									fontType = Patterns::CONTAINER;
								} else if (key == "CONTAINER_FORE") {
									foreType = Patterns::CONTAINER;
								} else if (key == "CONTAINER_BACK") {
									backType = Patterns::CONTAINER;
								} else if (key == "LIPSYNC_FONT") {
									fontType = Patterns::LIPSYNC;
								} else if (key == "LIPSYNC_FORE") {
									foreType = Patterns::LIPSYNC;
								} else if (key == "LIPSYNC_BACK") {
									backType = Patterns::LIPSYNC;
								} else if (key == "MIDI_FONT") {
									fontType = Patterns::MIDI;
								} else if (key == "MIDI_FORE") {
									foreType = Patterns::MIDI;
								} else if (key == "MIDI_BACK") {
									backType = Patterns::MIDI;
								} else if (key == "SHORTCUT_FONT") {
									fontType = Patterns::SHORTCUT;
								} else if (key == "SHORTCUT_FORE") {
									foreType = Patterns::SHORTCUT;
								} else if (key == "SHORTCUT_BACK") {
									backType = Patterns::SHORTCUT;
								} else if (key == "COMMENT_FONT") {
									fontType = Patterns::COMMENT;
								} else if (key == "COMMENT_FORE") {
									foreType = Patterns::COMMENT;
								} else if (key == "COMMENT_BACK") {
									backType = Patterns::COMMENT;
								}

								if (fontType != Patterns::ALL) {
									Color->GetPatternColor(fontType)->FontColor
											= System::Drawing::Color::FromArgb(Int32::Parse("FF" + value, System::Globalization::NumberStyles::HexNumber));
								} else if (foreType != Patterns::ALL) {
									Color->GetPatternColor(foreType)->ForeColor
											= System::Drawing::Color::FromArgb(Int32::Parse("FF" + value, System::Globalization::NumberStyles::HexNumber));
								} else if (backType != Patterns::ALL) {
									Color->GetPatternColor(backType)->BackColor
											= System::Drawing::Color::FromArgb(Int32::Parse("FF" + value, System::Globalization::NumberStyles::HexNumber));
								}
							} else if (section == "WINDOW") {
								if (key == "POS_MODE") {
									Window->Pos = (WindowStates::Type)Int32::Parse(value);
								} else if (key == "SIZE_MODE") {
									Window->Size = (WindowStates::Type)Int32::Parse(value);
								} else if (key == "LEFT") {
									Window->Left = Int32::Parse(value);
								} else if (key == "TOP") {
									Window->Top = Int32::Parse(value);
								} else if (key == "WIDTH") {
									Window->Width = Int32::Parse(value);
								} else if (key == "HEIGHT") {
									Window->Height = Int32::Parse(value);
								} else if (key == "CHILD_MAXIMIZED") {
									Window->MDIChildMaximized = (value == "True");
								}
							} else if (section == "VERSION") {
								if (key == "FREQUENCY") {
									Version->Frequency = (VersionCheck::Frequency)Int32::Parse(value);
								} else if (key == "NEXT_DAY_OF_WEEK") {
									Version->NextDayOfWeek = (System::DayOfWeek)Int32::Parse(value);
								} else if (key == "NEXT_DAY") {
									Version->NextDay = Int32::Parse(value);
								} else if (key == "LAST_CHECK") {
									Version->LastCheckDate = DateTime::Parse(value);
								} else if (key == "NEXT_CHECK") {
									Version->NextCheckDate = DateTime::Parse(value);
								} else if (key == "PROXY") {
									Version->ProxySetting = (Proxy::Settings)Int32::Parse(value);
								} else if (key == "PROXY_HOST") {
									Version->ProxyHost = value;
								} else if (key == "PROXY_PORT") {
									Version->ProxyPort = Int32::Parse(value);
								}
							} else {
								//throw(safe_cast<String^>("MetMotMk.ini ̃t@CtH[}bgႢ܂B"));
								continue;//Ƃ肠
							}
						}
					}
				}

				din->Close();
			} catch (System::String^ strError) {
				MessageBox::Show(strError, "error");
				din->Close();
			} catch (Exception^ e) {
				if (dynamic_cast<FileNotFoundException^>(e)) {
					//
				} else {
					MessageBox::Show("MetMotMk.ini Ǎɖ肪܂B\n" + e->Message, "error");
				}
			}
		}

	}//Option

}//MetMotMk
