#include "StdAfx.h"
#include "Pattern.h"

namespace MetMotMk {

	Pattern::Pattern(void)
	{
		ModelName = gcnew MMD::String("");
		vpd = gcnew MMD::VPD::Item();
		vpd->ModelName = gcnew MMD::String("");
		vmd = gcnew MMD::VMD::Item();
		vmd->Header->ModelName = gcnew MMD::String("");
		Patterns = gcnew PatternBuffer();
		CloseRect = gcnew Rectangle();
		OpenRect = gcnew Rectangle();
	}

	Pattern^ Pattern::Copy()
	{
		Pattern^ pattern = gcnew Pattern();

		//pattern->smf = smf;//smf ̓vO1Ȃ̂ŁAQƓnłB
		pattern->timeline = timeline;//timeline ̓vO1Ȃ̂ŁAQƓnłB
		pattern->Model = Model;//QƂRs[
		pattern->ModelName = ModelName->Copy();
		pattern->Type = Type;
		pattern->Begin = Begin->Copy();
		pattern->End = End->Copy();
		pattern->NoLength = NoLength;
		pattern->Repeat = Repeat;
		pattern->Step = Step->Copy();
		pattern->vpd = vpd->Copy();
		pattern->vmd = vmd->Copy();
		pattern->Top = Top;
		pattern->Height = Height;
		pattern->UpdateRectangle();

		return pattern;
	}

	System::Void Pattern::CopyFrom(Pattern^ src) {//Ɏw肳ꂽp^[̓eɃRs[B
		timeline = src->timeline;//timeline ̓vO1Ȃ̂ŁAQƓnłB
		Model = src->Model;//QƂRs[
		ModelName = src->ModelName->Copy();
		Type = src->Type;
		Begin = src->Begin->Copy();
		End = src->End->Copy();
		NoLength = src->NoLength;
		Repeat = src->Repeat;
		Step = src->Step->Copy();
		vpd = src->vpd->Copy();
		vmd = src->vmd->Copy();
		Top = src->Top;
		Height = src->Height;
		UpdateRectangle();
	}

	System::Void Pattern::UpdateRectangle() {//`TCYEʒu̍ČvZ
		m_Left = (int)System::Math::Round((double)Begin->GlobalTick * timeline->PixelsPerTick());

		//p^[̌JԂ݂̏Iʒu̎Zo
		SMF::Position^ pos_left = gcnew SMF::Position(timeline->smf);
		pos_left->GlobalTick = Begin->GlobalTick;//JnʒuZJn
		for (int i = 1; i < Repeat; i++) {//JԂ̃C^[ỏZ
			pos_left->Add(Step);
		}
		pos_left->GlobalTick += End->GlobalTick - Begin->GlobalTick;//{[begin`end_]_](JԂ-1)JԂ}+{[begin`end]̎}
		m_Width = (int)System::Math::Round((double)(pos_left->GlobalTick - Begin->GlobalTick) * timeline->PixelsPerTick());

		m_Right = m_Left + m_Width;

		UpdateScaledRectangle();
	}

	System::Void Pattern::UpdateRectangle(int width) {//p^[̉JԂ񐔂̍ČvZ(width=gEk̕\)
		int tickWidth = (int)System::Math::Round((double)width / (timeline->tickScale * timeline->PixelsPerTick()));//tickɕϊB
		if (tickWidth <= 0) {//[܂̓}CiX̏ꍇ
			tickWidth = 1;//I1ɐݒ
		}

		//p^[̌JԂ݂̏Iʒu̎Zo
		SMF::Position^ pos_left = gcnew SMF::Position(timeline->smf);
		pos_left->GlobalTick = Begin->GlobalTick;//JnʒuZJn
		int tickRight = pos_left->GlobalTick + tickWidth;//E[tickʒu
		Repeat = 0;
		int tick = pos_left->GlobalTick;
		while (pos_left->GlobalTick < tickRight) {
			tick = pos_left->GlobalTick;//StepZOtickۑB
			pos_left->Add(Step);
			Repeat++;
		}
		tick += End->GlobalTick - Begin->GlobalTick;//{[begin`end_]_](JԂ-1)JԂ}+{[begin`end]̎}
		m_Width = (int)System::Math::Round((double)(tick - Begin->GlobalTick) * timeline->PixelsPerTick());

		m_Right = m_Left + m_Width;

		UpdateScaledRectangle();
	}

	System::Void Pattern::UpdateScaledRectangle() {//gEkꂽ`TCYEʒu̍ČvZ(kڂςƂ̂ݎs)
		m_ScaledLeft = (int)System::Math::Round((double)m_Left * timeline->tickScale);
		m_ScaledWidth = (int)System::Math::Round((double)m_Width * timeline->tickScale);
		m_ScaledRight = m_ScaledLeft + m_ScaledWidth;
	}

}//MetMotMk
