#include "StdAfx.h"
#include "PatternBuffer.h"
#include "Pattern.h"

namespace MetMotMk {


	PatternBuffer::PatternBuffer(void)
	{
		Patterns = gcnew ArrayList();
		Left = -1;
		Top = -1;
		Right = -1;
		Bottom = -1;
	}

	System::Void PatternBuffer::AddPattern(Pattern^ pattern) {//p^[ǉB(PatternBuffer̋`̑傫XV)
		bool found = false;

		for (int i = 0; i < Patterns->Count; i++) {
			if (Patterns[i] == pattern) {
				found = true;
				break;
			}
		}

		if (!found) {//XgɊ܂܂Ȃꍇ͒ǉB
			Patterns->Add(pattern);

			//PatternBuffer̋`̑傫̍XV
			UpdateRectangle(pattern);
		}
	}

	System::Void PatternBuffer::RemovePattern(Pattern^ pattern) {//p^[菜B(PatternBuffer̋`̑傫XV)
		for (int i = 0; i < Patterns->Count; i++) {
			if (Patterns[i] == pattern) {
				RemovePatternAt(i);
			}
		}

	}

	System::Void PatternBuffer::RemovePatternAt(int index) {//p^[菜B(PatternBuffer̋`̑傫XV)
		Patterns->RemoveAt(index);

		//PatternBuffer̋`̑傫̍XV
		UpdateRectangle();
	}

	System::Void PatternBuffer::UpdateRectangle() {//i[ĂSp^[`̑傫̍ČvZ
		if (Patterns->Count > 0) {//XgłȂꍇ
			Pattern^ pat = GetPatternAt(0);
			Left = pat->Left;
			Top = pat->Top;
			Right = pat->Right;
			Bottom = pat->Bottom;
			for (int i = 1; i < Patterns->Count; i++) {
				UpdateRectangle(GetPatternAt(i));
			}
		}
	}

	System::Void PatternBuffer::UpdateRectangle(Pattern^ pattern) {//`̑傫̍XV
		if (Left < 0) {
			Left = pattern->Left;
		} else if (pattern->Left < Left) {
			Left = pattern->Left;
		}
		if (Top < 0) {
			Top = pattern->Top;
		} else if (pattern->Top < Top) {
			Top = pattern->Top;
		}
		if (Right < 0) {
			Right = pattern->Right;
		} else if (pattern->Right > Right) {
			Right = pattern->Right;
		}
		if (Bottom < 0) {
			Bottom = pattern->Bottom;
		} else if (pattern->Bottom > Bottom) {
			Bottom = pattern->Bottom;
		}
	}

	System::Void PatternBuffer::Clear() {//p^[RNṼNA
		Patterns->Clear();
		Left = -1;
		Top = -1;
		Right = -1;
		Bottom = -1;
	}

	Pattern^ PatternBuffer::GetPatternAt(int index) {//p^[̎擾
		return safe_cast<Pattern^>(Patterns[index]);
	}

	PatternBuffer^ PatternBuffer::Copy() {//PatternBufferCX^X̕
		PatternBuffer^ mb = gcnew PatternBuffer();

		for (int i = 0; i < Patterns->Count; i++) {
			//mb->AddPattern(GetPatternAt(i)->Copy());
			mb->AddPattern(GetPatternAt(i));//QƂn
		}

		return mb;
	}

	bool PatternBuffer::MultiModel() {
		bool multi_model = false;

		Model^ model;
		for (int i = 0; i < Count; i++) {
			Pattern^ pat = GetPatternAt(i);
			if (i == 0) {
				model = pat->Model;
			} else {
				if (pat->Model != model) {
					multi_model = true;
				}
			}
		}

		return multi_model;
	}

}//MetMotMk
