#include "StdAfx.h"
#include "Version.h"

namespace MetMotMk {

	Version::Version(void)
	{
		m_version = gcnew System::String(MetMotMk::VERSION);
		m_zip_version = MetMotMk::ZIP_VERSION;
	}

	String^ Version::ToString() {//o[WԂB
		return m_version;
	}

	int Version::GetSerial() {//o[Wԍo[Wrp̃VAԍɕϊB
		int serial;
		array<String^>^ ver = nullptr;
		array<String^>^ release = nullptr;//[Xł̃o[Wԍ
		array<String^>^ beta = nullptr;//ł̃o[Wԍ

		String^ v = m_version->Replace("", "b");
		ver = v->Split('b');
		release = ver[0]->Split('.');
		if (release[1]->Length == 1) {
			release[1] += "0";
		}
		if (ver->Length > 1) {
			beta = ver[1]->Split('.');
			if (beta[1]->Length == 1) {
				beta[1] += "0";
			}
		} else {
			beta = gcnew array<String^>(2);
			beta[0] = "0";
			beta[1] = "0";
		}

		serial = Int32::Parse(String::Format("{0:D2}{1:D2}{2:D1}{3:D2}{4:D2}{5:D2}",
										Int32::Parse(release[0]),
										(release->Length > 1) ? Int32::Parse(release[1]) : 0,
										(ver[1] == "" ) ? 8 : 1,
										Int32::Parse(beta[0]),
										Int32::Parse(beta[1]),
										m_zip_version));

		return serial;
	}

	System::Void Version::SetSerial(int serial) {//VAԍݒ肵ăo[WԍXVB
		int zip = serial % 100;
		serial /= 100;
		int beta_minor01 = serial % 10;
		serial /= 10;
		int beta_minor10 = serial % 10;
		serial /= 10;
		int beta_major = serial % 100;
		serial /= 100;
		int beta = serial % 10;
		serial /= 10;
		int release_minor01 = serial % 10;
		serial /= 10;
		int release_minor10 = serial % 10;
		int release_major = serial / 10;

		m_version = String::Format("{0:D}.{1:D}", release_major, release_minor10);
		if (release_minor01 > 0) {
			m_version += String::Format("{0:D}", release_minor01);
		}
		if (beta == 1) {
			m_version += String::Format("{0:D}.{1:D}", beta_major, beta_minor10);
			if (beta_minor01 > 0) {
				m_version += String::Format("{0:D}", beta_minor01);
			}
		}
		m_zip_version = zip;
	}

}//MetMotMk
