#include "StdAfx.h"
#include "SMF_Event.h"
#include "SMF.h"

namespace SMF {

	Event::Event(void)
	{
		DeltaTime = 0;
	}

	Event::Event(SMF::TempoChange^ tc) {//e|`FW񂩂MIDICxg𐶐B
		DeltaTime = 0;//()
		GlobalTick = tc->Tick;
		status = 0x51;
		Data = gcnew array<Byte>(3);
		int tempo = (int)System::Math::Round(60.0 * 1000.0 * 1000.0 / tc->Tempo);
		Data[0] = (tempo >> 16) & 0xff;
		Data[1] = (tempo >> 8) & 0xff;
		Data[2] = tempo & 0xff;
	}

	Event::Event(SMF::BeatChange^ bc) {//qύX񂩂MIDICxg𐶐B
		DeltaTime = 0;//()
		GlobalTick = bc->Tick;
		status = 0x58;
		Data = gcnew array<Byte>(4);
		Data[0] = bc->BeatInfo->nn;
		Data[1] = 1;
		for (int i = 2; i < bc->BeatInfo->dd; i <<= 1) {
			Data[1]++;
		}
		Data[2] = bc->BeatInfo->cc;
		Data[3] = bc->BeatInfo->bb;
	}

	String^ Event::GetEventName() {//Cxg̎擾
		String^ name;
		Beat^ beat = gcnew Beat();

		if (status >= 0x80) {//`lbZ[WESysExbZ[W
			switch (status & 0xf0) {
			case 0x80:
				name = "m[gIt";
				break;
			case 0x90:
				if (this->Data[1] == 00) {
					name = "m[gIt";
				} else {
					name = "m[gI";
				}
				break;
			case 0xa0:
				name = "|tHjbNL[vbV[";
				break;
			case 0xb0:
				name = "Rg[`FW";
				break;
			case 0xc0:
				name = "vO`FW";
				break;
			case 0xd0:
				name = "`lvbV[";
				break;
			case 0xe0:
				name = "sb`xh";
				break;
			case 0xf0:
				if (status == 0xf0 || status == 0xf7) {
					name = "SysExbZ[W";
					break;
				}
			default:
				name = "sMIDICxg";
			}
		} else {//^Cxg
			switch (status) {
			case 0x00:
				name = "V[PXԍ";
				break;
			case 0x01:
				name = "eLXg";
				break;
			case 0x02:
				name = "쌠\";
				break;
			case 0x03:
				name = "V[PX^gbN";
				break;
			case 0x04:
				name = "y햼";
				break;
			case 0x05:
				name = "̎";
				break;
			case 0x06:
				name = "}[J";
				break;
			case 0x07:
				name = "L[|Cg";
				break;
			case 0x20:
				name = "MIDI`lvtBbNX";
				break;
			case 0x2f:
				name = "GhIugbN";
				break;
			case 0x51:
				name = String::Format("Zbge|({0:F})", SMF::File::CalcTempo(this->Data));
				break;
			case 0x54:
				name = "SMPTEItZbg";
				break;
			case 0x58:
				beat->SetBeat(this->Data[0], 1 << this->Data[1], this->Data[2], this->Data[3]);
				name = String::Format("q({0:D}/{1:D})", beat->nn, beat->dd);
				break;
			case 0x59:
				name = "(" + SMF::File::key[(this->Data[0]+7) & 0xff, this->Data[1]] + ")";
				break;
			case 0x7f:
				name = "V[PTŗL̃^Cxg";
				break;
			default:
				name = "^Cxg̑";
			}
		}

		return name;
	}

} //SMF
