#include "StdAfx.h"
#include "SMF_Position.h"


namespace SMF {

	Position::Position(void)
	{
		BeatInfo = gcnew SMF::Beat();
		m_Measure = 1;
		m_Beat = 1;//ɂꂪ 0 ƁAMeasure ɒlƂ̌vZɎxႪoB
		m_Tick = 0;
	}

	Position::Position(SMF::File^ smf)
	{
		BeatInfo = gcnew SMF::Beat();
		this->smf = smf;
		m_Measure = 1;
		m_Beat = 1;//ɂꂪ 0 ƁAMeasure ɒlƂ̌vZɎxႪoB
		m_Tick = 0;
	}

	Position^ Position::Copy()
	{
		Position^ position = gcnew Position(smf);

		if (smf != nullptr) {//smfݒ肳Ăꍇ̂݁Aq̃Rs[sB
			position->BeatInfo = BeatInfo->Copy();
		}
		position->m_Measure = m_Measure;
		position->m_Beat = m_Beat;
		position->m_Tick = m_Tick;
		position->m_Frame = m_Frame;
		position->m_GlobalTick = m_GlobalTick;
		position->m_RegularTick = m_RegularTick;

		return position;
	}

	System::String^ Position::ToString(void) {//JE^[񐶐
		return String::Format("{0:D}:{1:D}:{2:D" + smf->Header.DeltaTime.ToString()->Length.ToString() + "}",
												m_Measure, m_Beat, m_Tick);
	}

	void Position::CalcPosition(CalcPositionMode mode) {//ʂTick珬߁EEtickZoB
		/*
		int bcp = 0;//ݎgp̔q̔qύXւ̃|C^
		SMF::BeatChange^ bc = safe_cast<SMF::BeatChange^>(smf->BeatChanges[bcp]);//ݎgp̔q̔qύX
		int dt = smf->Header.DeltaTime * bc->BeatInfo->cc / 24;
		int nextTick;
		*/
		CalcPositionMode mode_bak = mode;//ύXOmode

		//MessageBox::Show(String::Format("qύX̐={0:D}", smf->BeatChanges->Count));

		if (mode == FROM_FRAME) {//t[ԍPosition𐶐
			m_GlobalTick = GetTickFromFrame(m_Frame);
			mode = FROM_GLOBAL_TICK;//ʂTick̕ϊɕύX
		}

		//System::Diagnostics::Debug::WriteLine(System::String::Format("{0}; {1}:{2}:{3}", m_GlobalTick, m_Measure, m_Beat, m_Tick));
		if (mode == FROM_GLOBAL_TICK) {//ʂtickPosition𐶐
			for (int i = smf->BeatChanges->Count - 1; i >= 0 ; i--) {
				SMF::BeatChange^ bc = safe_cast<SMF::BeatChange^>(smf->BeatChanges[i]);
				if (m_GlobalTick >= bc->Tick) {
					int diffTick = m_GlobalTick - bc->Tick;
					int dt = smf->Header.DeltaTime * 4 / bc->BeatInfo->dd;//1tick
					int db = bc->BeatInfo->nn;//1߂̔
					m_Measure = bc->Measure + diffTick / (dt * db);
					diffTick %= dt * db;
					m_Beat = diffTick / dt + 1;
					m_Tick = diffTick % dt;
					BeatInfo->SetBeat(bc->BeatInfo);
					//System::Diagnostics::Debug::WriteLine(System::String::Format("{0} => {1}:{2}:{3}; {4}/{5}", m_GlobalTick, m_Measure, m_Beat, m_Tick,
					//												bc->BeatInfo->nn, bc->BeatInfo->dd));
					if (mode_bak == FROM_GLOBAL_TICK) {//Ƃ FROM_GLOBAL_TICK ꍇA
						m_Frame = (int)System::Math::Round(GetFrameFromTick(m_GlobalTick));//t[ԍvZB
					}
					break;
				}
			}
		} else if (mode == FROM_MEASURE) {//߁EEtickPosition𐶐Ԃ񂱂OKႤtick+m_tick͊ɈႤe|ɂȂĂ\
			for (int i = smf->BeatChanges->Count - 1; i >= 0 ; i--) {
				SMF::BeatChange^ bc = safe_cast<SMF::BeatChange^>(smf->BeatChanges[i]);
				if (m_Measure >= bc->Measure) {
					int diffMeasure = m_Measure - bc->Measure;
					int dt = smf->Header.DeltaTime * 4 / bc->BeatInfo->dd;//1tick
					int db = bc->BeatInfo->nn;//1߂̔
					m_GlobalTick = bc->Tick + (diffMeasure * db + m_Beat - 1) * dt + m_Tick;
					m_Frame = (int)System::Math::Round(GetFrameFromTick(m_GlobalTick));
					BeatInfo->SetBeat(bc->BeatInfo);
					//System::Diagnostics::Debug::WriteLine(System::String::Format("{0} <= {1}:{2}:{3}; {4}/{5}", m_GlobalTick, m_Measure, m_Beat, m_Tick,
					//												bc->BeatInfo->nn, bc->BeatInfo->dd));
					break;
				}
			}
		}
		System::Diagnostics::Debug::Assert(smf != nullptr && smf->BeatChanges->Count > 0 && BeatInfo->dd != 0,
			System::String::Format("smf != nullptr ŔqύXe[ułȂ({0})ƂAq̕ꂪ[ɂȂ̂͂B({1}; {2}:{3}:{4})",
									smf->BeatChanges->Count, m_GlobalTick, m_Measure, m_Beat, m_Tick));

		/*
		if (bcp < smf->BeatChanges->Count - 1) {//̔qύXƂ
			SMF::BeatChange^ nbc = safe_cast<SMF::BeatChange^>(smf->BeatChanges[bcp + 1]);
			nextTick = nbc->Tick;//̔qύXtick
		} else {//̔qύXƂ
			nextTick = smf->MaxTick + 1;//ŌtickɔqύX݂͑Ȃ̂ŁAnextTickɐݒ肷B
		}

		int tick = 0;
		int m = 0;//
		int b = 1;//
		while (tick <= smf->MaxTick) {

			if ((tick - bc->Tick) % (bc->BeatInfo->nn * dt) == 0) {//߂̓̂Ƃ
				m++;
				b = 1;
			}

			if (tick == nextTick) {//qύX̂Ƃ
				bcp++;
				bc = safe_cast<SMF::BeatChange^>(smf->BeatChanges[bcp]);
				if (bcp < smf->BeatChanges->Count - 1) {//̔qύXƂ
					SMF::BeatChange^ nbc = safe_cast<SMF::BeatChange^>(smf->BeatChanges[bcp + 1]);
					nextTick = nbc->Tick;//̔qύXtick
				} else {//̔qύXƂ
					nextTick = smf->MaxTick + 1;//ŌtickɔqύX݂͑Ȃ̂ŁAnextTickɐݒ肷B
				}
				dt = smf->Header.DeltaTime * bc->BeatInfo->cc / 24;
			}

			if (mode == FROM_GLOBAL_TICK) {//ʂtickPosition𐶐
				if (tick <= m_GlobalTick && m_GlobalTick < tick + dt) {//m_GlobalTick ݂ tick ƁA tick ̊Ԃ̏ꍇ
					m_Measure = m;
					m_Beat = b;
					m_Tick = m_GlobalTick - tick;
					BeatInfo->SetBeat(bc->BeatInfo);
					if (mode_bak == FROM_GLOBAL_TICK) {//Ƃ FROM_GLOBAL_TICK ꍇA
						m_Frame = (int)System::Math::Round(GetFrameFromTick(m_GlobalTick));//t[ԍvZB
					}
					break;
				}
			} else if (mode == FROM_MEASURE) {//߁EEtickPosition𐶐Ԃ񂱂OKႤtick+m_tick͊ɈႤe|ɂȂĂ\
				if (m == m_Measure && b == m_Beat) {//߂Ɣvꍇ
					m_GlobalTick = tick + m_Tick;//݂ tick ɐݒ肳ꂽ m_Tick ZB
					m_Frame = (int)System::Math::Round(GetFrameFromTick(m_GlobalTick));
					BeatInfo->SetBeat(bc->BeatInfo);
					break;
				}
			}

			tick += dt;
			b++;
		}
		*/
	}

	int Position::GetTickFromFrame(double frame) {//t[ԍAʂTick𓾂B
		int tick;

		SMF::TempoChange^ tc = safe_cast<SMF::TempoChange^>(smf->TempoChanges[0]);
		for (int i = 1; i < smf->TempoChanges->Count; i++) {
			SMF::TempoChange^ ntc = safe_cast<SMF::TempoChange^>(smf->TempoChanges[i]);
			if (tc->Frame <= frame && frame < ntc->Frame) {
				//tick = tc->Tick + (frame - tc->Frame) * (ntc->Tick - tc->Tick) / (ntc->Frame - tc->Frame);//vZ@1
				tick = tc->Tick + (int)System::Math::Round((frame - tc->Frame) * smf->Header.DeltaTime * tc->Tempo / (60.0 * 30.0));//vZ@2
				break;
			}
			tc = ntc;
		}

		return tick;
	}

	double Position::GetFrameFromTick(int tick) {//ʂTickAt[ԍ𓾂B
		double frame;

		SMF::TempoChange^ tc = safe_cast<SMF::TempoChange^>(smf->TempoChanges[0]);
		for (int i = 1; i < smf->TempoChanges->Count; i++) {
			SMF::TempoChange^ ntc = safe_cast<SMF::TempoChange^>(smf->TempoChanges[i]);
			if (tc->Tick <= tick && tick < ntc->Tick) {
				frame = tc->Frame + (tick - tc->Tick) * 60.0 * 30.0 / (smf->Header.DeltaTime * tc->Tempo);
				break;
			}
			tc = ntc;
		}

		return frame;
	}

	System::Void Position::Add(SMF::Position^ dp) {//߂ƂƂB
		//ł܂ǂ͓B
		int m = dp->Measure;
		int b = dp->Beat;
		int t = dp->Tick;

		//߂̉Z
		Measure += m;

		//̉Z
		while (b > 0) {
			int db = BeatInfo->nn - Beat + 1;//̏߂̓܂ł̔B
			if (b < db) {//Z锏Ȁ߂̓܂ł̔菭Ȃꍇ
				//Ză[v𔲂B
				Beat += b;
				break;
			} else {//Z锏Ȁ߂̓𒴂ꍇA
				//̏߂̓ɈړB
				Measure++;
				Beat = 1;
				//Z锏B
				b -= db;
			}
		}

		//tick̉Z
		while (t > 0) {
			int dt = smf->Header.DeltaTime * 4 / BeatInfo->dd - Tick + 1;//̔̓܂łtickB
			if (t < dt) {//ZtickA̔̓܂łtick菭Ȃꍇ
				//Ză[v𔲂B
				Tick += t;
				break;
			} else {//ZtickȀ߂̓𒴂ꍇA
				//̏߂̓ɈړB
				if (Beat == BeatInfo->nn) {//ߓ̍Ō̔̂Ƃ
					//߂̓ɖ߂B
					Measure++;
					Beat = 1;
				} else {//łȂƂ
					//ZB
					Beat++;
				}
				Tick = 0;
				//Z锏B
				t -= dt;
			}
		}
	}

}//SMF
